// NEW ENGLAND
// A Random Map for Age of Empires III: The Third One
include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//Balance Start

/*
An attempt to fix only the biggest flaws in AOE 3 Vanilla Balance
Using only Scenario Triggers inside the Random Map Scripts for maximum compatibility
Draws some Ideas from the Community ESOC for TAD
and took some changes from the Asian Dynasties
Original Idea by Rikikipu: https://eso-community.net/viewtopic.php?t=6550
This Version fixes some remaining issues with Cards and Tech not taking changes into consideration
and adds some additional Balance Changes

Changes:
1. Halb -10 Food and Gold Cost, Ruyters -5 food, -5 gold 
2. TP -50 Wood Cost(from the Asian Dynasties)
3. Cuirassier -25 Base HP and -5 Gold and -5 Food Cost
4. Oprichnik -25 Base HP and +30 Food Cost, Strelet -5s train time
5. Indian Rajputs -20 wood, Mahouts -50 food and -50 wood, Gurkha -10 gold, +20 HP, Urumi Enabled
6. Monitor Cost decreased by 200 Gold
7. Ports start the game with +50 Wood
8. Tomahawks -25 food, Kanya Horsemen -25 wood, Mantlets -25 wood
9. Ashigarus +10 gold, +5s train time, -1 speed, Yabusames -20 gold, Samurai -10 Food and Gold, +10 HP, -1s train time
10. Dog Soldiers -40s train time, Skull Knights -30s train time
11. Iroquois Travois -15s train time, Medicine Men -15s train time, Warrior Priests -10s train time
12. Heavy Cannons, Great Bombards, Rockets +100 HP, Gatling Guns +50 HP
13. Outposts, Warhuts, Nobles Huts, Blockhosues +7 Build limit, Castles +5 Build limit

*/

void balanceVanilla(void)
{
for(i=1; <cNumberPlayers)
{	
	rmCreateTrigger("OverallBalance"+i);
    rmSwitchToTrigger(rmTriggerID("OverallBalance"+i));
	rmAddTriggerCondition("Timer");
    rmSetTriggerPriority(3);
    rmSetTriggerActive(true);
    rmSetTriggerRunImmediately(true);
    rmSetTriggerLoop(false);   
	rmSetTriggerConditionParamInt("Param1", 3);	
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "Factory");
    rmSetTriggerEffectParamInt("PlayerID", i);
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "ypBankAsian");
    rmSetTriggerEffectParamInt("PlayerID", i);
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "ypGroveBuilding");
    rmSetTriggerEffectParamInt("PlayerID", i);
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "CWallGate");
    rmSetTriggerEffectParamInt("PlayerID", i);
		
    rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "TradingPost");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 16);
    rmSetTriggerEffectParamInt("Delta", -100);
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Monitor");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 15);
    rmSetTriggerEffectParamInt("Delta", -200);	
		
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Cannon");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", 0);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "GreatBombard");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", 0);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Rocket");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", 0);	
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Cannon");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "GreatBombard");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Rocket");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpGatlingGun");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 50);	
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "ypConsulateCannon");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "ypConsulateGreatBombard");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "TownCenter");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 5);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "Outpost");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "ypCastle");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 5);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "WarHut");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "NoblesHut");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "Blockhouse");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "CoveredWagon");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
	rmSetTriggerEffectParamInt("Delta", 100);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "FortWagon");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
	rmSetTriggerEffectParamInt("Delta", 100);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "FactoryWagon");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
	rmSetTriggerEffectParamInt("Delta", 100);

	if ( rmGetPlayerCiv(i) == 3	){
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Cuirassier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Cuirassier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Cuirassier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
	}
	
	if ( rmGetPlayerCiv(i) == 21	){
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -150);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRajput");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -20);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypNatMercGurkha");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypNatMercGurkha");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypSepoy");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", -0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMercFlailiphant");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 1);
		rmSetTriggerEffectParamInt("Delta", 1);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRajput");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -5);
	}
	
	if ( rmGetPlayerCiv(i) == 3
	|| rmGetPlayerCiv(i) == 4
	|| rmGetPlayerCiv(i) == 5
	|| rmGetPlayerCiv(i) == 1
	){
	
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Ruyter");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Ruyter");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -5);
	}
	
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("Portuguese")){
      rmCreateTrigger("Wood babe"+i);
      rmSwitchToTrigger(rmTriggerID("Wood babe"+i));
      rmSetTriggerPriority(3); 
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);
      rmAddTriggerCondition("Always");
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmSetTriggerEffectParam("ResName", "Wood", false);
      rmSetTriggerEffectParam("Amount", "50", false);
    }	

	if ( rmGetPlayerCiv(i) == rmGetCivID("XPSioux")){
		//Uhlan 35s +5 +4
		//WarWagon 60 +9 +6
	
	rmCreateTrigger("DogTrainTime"+i);
		rmSwitchToTrigger(rmTriggerID("DogTrainTime"+i));
		rmSetTriggerPriority(3);
		rmSetTriggerActive(true);
		rmSetTriggerRunImmediately(false);
		rmSetTriggerLoop(false); 
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpDogSoldier");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -40);
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpMedicineMan");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -15);
	}
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("XPAztec")){
		//Uhlan 35s +5 +4
		//WarWagon 60 +9 +6
	
	rmCreateTrigger("SkullTrainTime"+i);
		rmSwitchToTrigger(rmTriggerID("SkullTrainTime"+i));
		rmSetTriggerPriority(3);
		rmSetTriggerActive(true);
		rmSetTriggerRunImmediately(false);
		rmSetTriggerLoop(false); 
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpSkullKnight");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -25);
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpMedicineManAztec");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -10);
	}
	
	if ( rmGetPlayerCiv(i) == 6	){
	
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -8);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Oprichnik");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 30);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Oprichnik");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Strelet");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -5);
	}
	
	if ( rmGetPlayerCiv(i) == 19	){
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypAshigaru");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypYabusame");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -20);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -1);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypAshigaru");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", 1);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypShrineJapanese");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 10);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypAshigaru");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 1);
		rmSetTriggerEffectParamInt("Delta", -1);
	}
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("XPIroquois")){
		//Uhlan 35s +5 +4
		//WarWagon 60 +9 +6
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpTomahawk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpMantlet");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpBuilder");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -15);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpMedicineMan");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -15);
	}

	if ( rmGetPlayerCiv(i) == rmGetCivID("Dutch")){
		//Settler +25
		//Dutch +50%
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Settler");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 10);
		rmSetTriggerEffectParamInt("Delta", 15);
	}
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("XPSioux")){
		//Axe Rider -40 Food
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpAxeRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -40);
	}

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -6);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -6);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);

		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -3);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantSmuggler");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -3);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantSmuggler");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
	
}
}
//Balance Ende
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx 

// Main entry point for random map script
void main(void)
{
   // Text
   // These status text lines are used to manually animate the map generation progress bar
   rmSetStatusText("",0.01);

   //Chooses which natives appear on the map
   int subCiv0=-1;
   int subCiv1=-1;
   int subCiv2=-1;
   int subCiv3=-1;

    // Thingy to randomize location of the four "equal" VP sites.
    int vpLocation=-1;
    // vpLocation = rmRandInt(1,4);
    vpLocation = 1;

    int whichVariation=-1;
    // Used to be 1-4, but taking the mega-cliffs out for now.
    whichVariation = rmRandInt(1,2);

    int whichNative=rmRandInt(1,4);
    if ( whichNative > 1 )
    {
        subCiv0=rmGetCivID("Zen");
        rmEchoInfo("subCiv0 is Zen "+subCiv0);

        subCiv1=rmGetCivID("Shaolin");
        rmEchoInfo("subCiv1 is Shaolin "+subCiv1);
    }
    else
    {
        subCiv0=rmGetCivID("Zen");
        rmEchoInfo("subCiv0 is Zen "+subCiv0);

        subCiv1=rmGetCivID("Shaolin");
        rmEchoInfo("subCiv1 is Shaolin "+subCiv1);
    }

    subCiv2=rmGetCivID("Zen");
    rmEchoInfo("subCiv2 is Zen "+subCiv2);
    
    subCiv3=rmGetCivID("Shaolin");
    rmEchoInfo("subCiv2 is Shaolin "+subCiv2);

    rmSetSubCiv(0, "Zen", true);
    rmSetSubCiv(1, "Shaolin", true);
    rmSetSubCiv(2, "Zen", true);
    rmSetSubCiv(3, "Shaolin", true);

    float handedness = rmRandFloat(0, 1);

   // Picks the map size
    int playerTiles=12500;
   if (cNumberNonGaiaPlayers >4)
        playerTiles = 11500;

   // Picks default terrain and water
   rmSetSeaType("Atlantic Coast");
   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);

    // Some map turbulence...
    rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);  // Like Texas for the moment.
    rmSetMapElevationHeightBlend(0.2);

   // Picks a default water height
   rmSetSeaLevel(4.0);
   rmEnableLocalWater(false);
   rmTerrainInitialize("water");
    rmSetMapType("CentralAfrica");
    rmSetMapType("Deccan");
    rmSetMapType("Borneo");
    rmSetMapType("water");
    rmSetWorldCircleConstraint(true);
    rmSetWindMagnitude(2.0);
    // rmSetLightingSet("SthAraucaniaLight");
    rmSetLightingSet("SthAraucaniaLight");
    rmSetMapType("grass");

    // Sets up the lighting change trigger - happy dawn in New England
    // REMOVED
    /*
    rmCreateTrigger("Day");
   rmSwitchToTrigger(rmTriggerID("Day"));
   rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 2);
   rmAddTriggerEffect("Set Lighting");
   rmSetTriggerEffectParam("SetName", "new england");
   rmSetTriggerEffectParamInt("FadeTime", 120);
   */

    // Choose mercs.
    chooseMercs();

   // Define some classes. These are used later for constraints.
   int classPlayer=rmDefineClass("player");
   rmDefineClass("classCliff");
   rmDefineClass("classPatch");
    rmDefineClass("classWall");
   int classbigContinent=rmDefineClass("big continent");
   rmDefineClass("corner");
   rmDefineClass("starting settlement");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("importantItem");
    rmDefineClass("secrets");
    rmDefineClass("socketClass");
    rmDefineClass("nuggets");

   // -------------Define constraints
   // These are used to have objects and areas avoid each other
   
   // Map edge constraints
   int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
   int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, 12.0);

   // Player constraints
   int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
   int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);

   // Directional constraints
    int Northwestward=rmCreatePieConstraint("northwestMapConstraint", 0.6, 0.6, 0, rmZFractionToMeters(0.9), rmDegreesToRadians(285), rmDegreesToRadians(75));  // 225 135, 300, 45
   int Southeastward=rmCreatePieConstraint("southeastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(90), rmDegreesToRadians(270));


   // Resource avoidance
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
   int avoidDeer=rmCreateTypeDistanceConstraint("food avoids food", "ypWildElephant", 45.0);
   int avoidNilgai=rmCreateTypeDistanceConstraint("food avoids food", "ypNilgai", 45.0);
    int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 30.0);
   int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35);
   int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 35.0);
   int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 20.0);
   int avoidNuggetSmall=rmCreateTypeDistanceConstraint("nugget avoid nugget small", "AbstractNugget", 10.0);

   // Avoid impassable land
    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
    int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
    int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 30.0);
    int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
    int wallConstraint=rmCreateClassDistanceConstraint("wall vs. wall", rmClassID("classWall"), 40.0);
    int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 40.0);
    int avoidGoat=rmCreateTypeDistanceConstraint("sheep avoids sheep", "ypgoat", 40.0);

   // Specify true so constraint stays outside of circle (i.e. inside corners)
   int cornerConstraint0=rmCreateCornerConstraint("in corner 0", 0, true);
   int cornerConstraint1=rmCreateCornerConstraint("in corner 1", 1, true);
   int cornerConstraint2=rmCreateCornerConstraint("in corner 2", 2, true);
   int cornerConstraint3=rmCreateCornerConstraint("in corner 3", 3, true);

   // Unit avoidance
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
   int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

   // ships vs. ships
   int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);

   // Decoration avoidance
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
   int avoidAll2=rmCreateTypeDistanceConstraint("avoid all", "all", 2.0);
   int avoidImpassableLand2=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
   int avoidNuggetWater=rmCreateTypeDistanceConstraint("nugget vs. nugget water", "AbstractNugget", 55.0);
   int avoidLand = rmCreateTerrainDistanceConstraint("ship avoid land", "land", true, 15.0);
   int nuggetVsFlag = rmCreateTypeDistanceConstraint("nugget v flag", "HomeCityWaterSpawnFlag", 8.0);
   
   // VP avoidance
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
   int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 30.0);
    int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 12.0);

   // Constraint to avoid water.
   int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
   int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water 15", "Land", false, 15.0);
   int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
   int avoidWater30 = rmCreateTerrainDistanceConstraint("avoid water mid-long", "Land", false, 30.0);
   int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);

   // New extra stuff for water spawn point avoidance.
    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

    int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

    int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);

   // Text
   rmSetStatusText("",0.10);

    // DEFINE AREAS
   // Set up player starting locations. These are just used to place Caravels away from each other.
   /* DAL - old placement.
    rmSetPlacementSection(0.35, 0.65);
   rmSetTeamSpacingModifier(0.50);
   rmPlacePlayersCircular(0.45, 0.45, rmDegreesToRadians(5.0));
    */

   // Text
   rmSetStatusText("",0.20);

    // Build up big continent - called, unoriginally enough, "big continent"
   int bigContinentID=rmCreateArea("big continent");
   rmSetAreaSize(bigContinentID, 0.52, 0.52);       // 0.65, 0.65
   rmSetAreaWarnFailure(bigContinentID, false);
   rmAddAreaConstraint(bigContinentID, longPlayerConstraint);
   rmAddAreaToClass(bigContinentID, classbigContinent);
   rmSetAreaSmoothDistance(bigContinentID, 25);
    rmSetAreaMix(bigContinentID, "araucania_dirt_b");
   rmSetAreaElevationType(bigContinentID, cElevTurbulence);
   rmSetAreaElevationVariation(bigContinentID, 2.0);
   rmSetAreaBaseHeight(bigContinentID, 6.0);
   rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
   rmSetAreaElevationOctaves(bigContinentID, 3);
   rmSetAreaElevationPersistence(bigContinentID, 0.2);      
    rmSetAreaCoherence(bigContinentID, 0.5);
    rmSetAreaLocation(bigContinentID, 0.5, 0.85);
   rmSetAreaEdgeFilling(bigContinentID, 5);
    rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);
    rmBuildArea(bigContinentID);

    rmSetStatusText("",0.30);

    // Build up small continent spurs called "small continent spur 1 & 2"
   int smallContinent1ID=rmCreateArea("small continent spur 1");
   rmSetAreaSize(smallContinent1ID, 0.15, 0.15);
   rmSetAreaWarnFailure(smallContinent1ID, false);
   rmAddAreaConstraint(smallContinent1ID, longPlayerConstraint);
   rmAddAreaToClass(smallContinent1ID, classbigContinent);
   rmSetAreaSmoothDistance(smallContinent1ID, 25);
    rmSetAreaMix(smallContinent1ID, "caribbean grass");
   rmSetAreaElevationType(smallContinent1ID, cElevTurbulence);
   rmSetAreaElevationVariation(smallContinent1ID, 2.0);
   rmSetAreaBaseHeight(smallContinent1ID, 6.0);
   rmSetAreaElevationMinFrequency(smallContinent1ID, 0.09);
   rmSetAreaElevationOctaves(smallContinent1ID, 3);
   rmSetAreaElevationPersistence(smallContinent1ID, 0.2);      
    rmSetAreaCoherence(smallContinent1ID, 0.5);
    rmSetAreaLocation(smallContinent1ID, 0.8, 0.6);
   rmSetAreaEdgeFilling(smallContinent1ID, 5);
   rmSetAreaObeyWorldCircleConstraint(smallContinent1ID, false);
    rmBuildArea(smallContinent1ID);

   rmSetStatusText("",0.35);

    // Build up small continent spurs called "small continent spur 1 & 2"
   int smallContinent2ID=rmCreateArea("small continent spur 2");
   rmSetAreaSize(smallContinent2ID, 0.15, 0.15);
   rmSetAreaWarnFailure(smallContinent2ID, false);
   rmAddAreaConstraint(smallContinent2ID, longPlayerConstraint);
   rmAddAreaToClass(smallContinent2ID, classbigContinent);
   rmSetAreaSmoothDistance(smallContinent2ID, 25);
    rmSetAreaMix(smallContinent2ID, "caribbean grass");
   rmSetAreaElevationType(smallContinent2ID, cElevTurbulence);
   rmSetAreaElevationVariation(smallContinent2ID, 2.0);
   rmSetAreaBaseHeight(smallContinent2ID, 6.0);
   rmSetAreaElevationMinFrequency(smallContinent2ID, 0.09);
   rmSetAreaElevationOctaves(smallContinent2ID, 3);
   rmSetAreaElevationPersistence(smallContinent2ID, 0.2);      
    rmSetAreaCoherence(smallContinent2ID, 0.5);
    rmSetAreaLocation(smallContinent2ID, 0.2, 0.6);
   rmSetAreaEdgeFilling(smallContinent2ID, 5);
   rmSetAreaObeyWorldCircleConstraint(smallContinent2ID, false);
    rmBuildArea(smallContinent2ID);

    if ( cNumberTeams == 2 )
    {
        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.2, 0.5, 0.2, 0.8, 0.0, 0.2);

        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.8, 0.5, 0.8, 0.8, 0.0, 0.2);
    }
    else
    {
       rmSetPlacementSection(0.75, 0.25);
       rmSetTeamSpacingModifier(0.75);
       rmPlacePlayersCircular(0.4, 0.4, 0);
    }

    // Set up player areas.
   float playerFraction=rmAreaTilesToFraction(100);
   for(i=1; <cNumberPlayers)
   {
      // Create the area.
      int id=rmCreateArea("Player"+i);
      // Assign to the player.
      rmSetPlayerArea(i, id);
      // Set the size.
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      // rmAddAreaConstraint(id, playerConstraint); 
      // rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmSetAreaLocPlayer(id, i);
      rmSetAreaWarnFailure(id, false);
   }

   // Build the areas.
   rmBuildAllAreas();

   // Placement order
   // Trade route -> Lakes -> Natives -> Secrets -> Cliffs -> Nuggets
   // Text
   rmSetStatusText("",0.40);

   // TRADE ROUTES
    int tradeRouteID = rmCreateTradeRoute();

    int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
    rmSetObjectDefAllowOverlap(socketID, true);
    rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
    rmSetObjectDefMinDistance(socketID, 0.0);
    rmSetObjectDefMaxDistance(socketID, 8.0);
    if ( cNumberNonGaiaPlayers < 4 )
    {
        rmAddObjectDefConstraint(socketID, avoidWater15);                   // To make it avoid the water and the cliffs.
    }

    else 
    {
        rmAddObjectDefConstraint(socketID, avoidWater20);                   // To make it avoid the water and the cliffs - by more if larger map
    }

    // Hacky trade route stuff for weird FFA cases, to handle player placement.
    if ( cNumberTeams == 3 || cNumberTeams > 4 )
    {
        rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.8);
    }
    else
    {
        rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.9);
    }
    rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.9);

    if ( cNumberNonGaiaPlayers < 4 )
    {
        rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.5, 0.45, 10, 2);
    }
    else
    {
        rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.5, 0.4, 10, 4);
    }
   
   bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "water");
   if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 

    // add the meeting poles along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
   vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.0);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.3);
    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.7);
    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 1.0);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

    // CLIFFS
    int plateauClass=rmDefineClass("plateau");
    int plateauConstraint=rmCreateClassDistanceConstraint("plateau vs. plateau", rmClassID("plateau"), 20.0);
    int bigCliff1ID=rmCreateArea("big cliff 1");
    
    // Place Lakes only in Variations 1 & 2.
    if ( whichVariation < 3 )
    {
        if ( cNumberNonGaiaPlayers < 4 )
            rmSetAreaSize(bigCliff1ID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(600));
        else
            rmSetAreaSize(bigCliff1ID, rmAreaTilesToFraction(900), rmAreaTilesToFraction(900));
        rmSetAreaCliffType(bigCliff1ID, "SPC Caribbean");
        rmSetAreaCliffHeight(bigCliff1ID, 10, 1.0, 1.0);
        rmSetAreaMinBlobs(bigCliff1ID, 3);
        rmSetAreaMaxBlobs(bigCliff1ID, 5);
        rmSetAreaMinBlobDistance(bigCliff1ID, 15.0);
        rmSetAreaMaxBlobDistance(bigCliff1ID, 25.0);
        rmAddAreaToClass(bigCliff1ID, plateauClass);
        rmAddAreaConstraint(bigCliff1ID, playerConstraint);
        rmAddAreaConstraint(bigCliff1ID, avoidSocket);
        rmAddAreaConstraint(bigCliff1ID, avoidTradeRoute);
        rmAddAreaConstraint(bigCliff1ID, avoidImportantItem);
        rmSetAreaLocation(bigCliff1ID, 0.38, 0.65);
        rmAddAreaInfluenceSegment(bigCliff1ID, 0.4, 0.52, 0.35, 0.68);
        rmSetAreaCoherence(bigCliff1ID, 0.4);
        rmSetAreaCliffEdge(bigCliff1ID, 1, 0.6, 0.1, 1.0, 0);  // DAL NOTE: Number of edges, second is size of each edge, third is variance
        rmSetAreaCliffPainting(bigCliff1ID, true, true, true, 1.5, true);
        rmSetAreaHeightBlend(bigCliff1ID, 1.0);
        rmSetAreaMix(bigCliff1ID, "andes_grass_a");
        rmAddAreaTerrainLayer(bigCliff1ID, "andes\ground07_and", 0, 2);
        rmSetAreaSmoothDistance(bigCliff1ID, 15);
        
        rmSetAreaWarnFailure(bigCliff1ID, false);
        rmBuildArea(bigCliff1ID);
        
        int bigCliff2ID=rmCreateArea("big cliff 2");
        if ( cNumberNonGaiaPlayers < 4 )
            rmSetAreaSize(bigCliff2ID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(600));
        else
            rmSetAreaSize(bigCliff2ID, rmAreaTilesToFraction(900), rmAreaTilesToFraction(900));

        rmSetAreaCliffType(bigCliff2ID, "SPC Caribbean");
        rmSetAreaCliffHeight(bigCliff1ID, 10, 1.0, 1.0);
        rmSetAreaMinBlobs(bigCliff2ID, 3);
        rmSetAreaMaxBlobs(bigCliff2ID, 5);
        rmSetAreaMinBlobDistance(bigCliff2ID, 15.0);
        rmSetAreaMaxBlobDistance(bigCliff2ID, 25.0);
        rmAddAreaToClass(bigCliff1ID, plateauClass);
        rmAddAreaConstraint(bigCliff2ID, playerConstraint);
        rmAddAreaConstraint(bigCliff2ID, avoidSocket);
        rmAddAreaConstraint(bigCliff2ID, avoidTradeRoute);
        rmAddAreaConstraint(bigCliff2ID, avoidImportantItem);
        rmSetAreaLocation(bigCliff2ID, 0.62, 0.65);
        rmAddAreaInfluenceSegment(bigCliff1ID, 0.6, 0.52, 0.65, 0.68);
        rmSetAreaCoherence(bigCliff2ID, 0.4);
        rmSetAreaCliffEdge(bigCliff2ID, 1, 0.6, 0.1, 1.0, 0);  // DAL NOTE: Number of edges, second is size of each edge, third is variance
        rmSetAreaCliffPainting(bigCliff2ID, true, true, true, 1.5, true);
        rmSetAreaHeightBlend(bigCliff2ID, 1.0);
        rmSetAreaMix(bigCliff2ID, "andes_grass_a");
        rmAddAreaTerrainLayer(bigCliff2ID, "andes\ground07_and", 0, 2);
        rmSetAreaSmoothDistance(bigCliff2ID, 15);
        
        rmSetAreaWarnFailure(bigCliff2ID, false);
        rmBuildArea(bigCliff2ID);
    }

    // A few smallish cliffs on the northwest side (inland)
    int cliffID=rmCreateArea("cliff "+i);
    rmSetAreaSize(cliffID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
    rmSetAreaWarnFailure(cliffID, false);
    rmSetAreaCliffType(cliffID, "SPC Caribbean");
    rmAddAreaToClass(cliffID, rmClassID("classCliff")); // Attempt to keep cliffs away from each other.

    // rmSetAreaCliffEdge(cliffID, 1, 0.6, 0.1, 1.0, 0);
    rmSetAreaCliffEdge(cliffID, 1, 1);
    rmSetAreaCliffPainting(cliffID, true, true, true, 1.5, true);
    rmSetAreaCliffHeight(cliffID, 6, 1.0, 1.0);
    rmSetAreaHeightBlend(cliffID, 1.0);
    rmAddAreaTerrainLayer(cliffID, "andes\ground07_and", 0, 2);

    rmAddAreaConstraint(cliffID, avoidCliffs);              // Avoid other cliffs, please!
    rmAddAreaConstraint(cliffID, avoidImportantItem);
    rmAddAreaConstraint(cliffID, avoidTradeRoute);
    rmAddAreaConstraint(cliffID, avoidWater20);
    rmAddAreaConstraint(cliffID, Northwestward);                // Cliff are on the northwest side of the map.
    rmSetAreaSmoothDistance(cliffID, 10);
    rmSetAreaCoherence(cliffID, 0.25);

    rmBuildArea(cliffID);
    
   // NATIVE AMERICANS
   // Text
   rmSetStatusText("",0.50);

   float NativeVillageLoc = rmRandFloat(0,1);
     
   // Huron are always on the mainland
   int huronVillageAID = -1;
   int huronVillageType = rmRandInt(1,3);
   huronVillageAID = rmCreateGrouping("huron village A", "native shaolin temple mongol 0"+huronVillageType);
   rmSetGroupingMinDistance(huronVillageAID, 0.0);
   rmSetGroupingMaxDistance(huronVillageAID, rmXFractionToMeters(0.05));
   rmAddGroupingConstraint(huronVillageAID, avoidImpassableLand);
   rmAddGroupingToClass(huronVillageAID, rmClassID("importantItem"));
   rmAddGroupingConstraint(huronVillageAID, avoidTradeRoute);
   rmPlaceGroupingAtLoc(huronVillageAID, 0, 0.35, 0.8);

    
    int huronVillageBID = -1;
    huronVillageType = rmRandInt(1,3);
    huronVillageBID = rmCreateGrouping("huron village B", "native shaolin temple mongol 0"+huronVillageType);
    rmSetGroupingMinDistance(huronVillageBID, 0.0);
    rmSetGroupingMaxDistance(huronVillageBID, rmXFractionToMeters(0.05));
    rmAddGroupingConstraint(huronVillageBID, avoidImpassableLand);
    rmAddGroupingToClass(huronVillageBID, rmClassID("importantItem"));
    rmAddGroupingConstraint(huronVillageBID, avoidTradeRoute);
    rmPlaceGroupingAtLoc(huronVillageBID, 0, 0.65, 0.8);
    
    int huronVillageCID = -1;
    huronVillageType = rmRandInt(1,3);
    huronVillageCID = rmCreateGrouping("huron village C", "native zen temple cj 0"+huronVillageType);
    rmSetGroupingMinDistance(huronVillageCID, 0.0);
    rmSetGroupingMaxDistance(huronVillageCID, rmXFractionToMeters(0.05));
    rmAddGroupingConstraint(huronVillageCID, avoidImpassableLand);
    rmAddGroupingConstraint(huronVillageCID, avoidStartingUnits);
    rmAddGroupingToClass(huronVillageCID, rmClassID("importantItem"));
    rmAddGroupingConstraint(huronVillageCID, avoidTradeRoute);
    rmPlaceGroupingAtLoc(huronVillageCID, 0, 0.3, 0.48);
    
    int huronVillageDID = -1;
    huronVillageType = rmRandInt(1,3);
    huronVillageDID = rmCreateGrouping("huron village D", "native zen temple cj 0"+huronVillageType);
    rmSetGroupingMinDistance(huronVillageDID, 0.0);
    rmSetGroupingMaxDistance(huronVillageDID, rmXFractionToMeters(0.05));
    rmAddGroupingConstraint(huronVillageDID, avoidImpassableLand);
    rmAddGroupingConstraint(huronVillageDID, avoidStartingUnits);
    rmAddGroupingToClass(huronVillageDID, rmClassID("importantItem"));
    rmAddGroupingConstraint(huronVillageDID, avoidTradeRoute);
    rmPlaceGroupingAtLoc(huronVillageDID, 0, 0.7, 0.52);

   // Starting Unit placement
    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
    rmSetObjectDefMinDistance(startingUnits, 5.0);
    rmSetObjectDefMaxDistance(startingUnits, 10.0);
    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
    rmAddObjectDefConstraint(startingUnits, avoidAll);

    int startingTCID= rmCreateObjectDef("startingTC");
    if ( rmGetNomadStart())
    {
        rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
    }
    else
    {
        rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
    }
    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));

    int silverType = -1;
    int playerGoldID = -1;

    int StartAreaTreeID=rmCreateObjectDef("starting trees");
    rmAddObjectDefItem(StartAreaTreeID, "TreeCaribbean", 1, 0.0);
    rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
    rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
	
   int startingUnits2 = rmCreateObjectDef("extra units");
   rmAddObjectDefItem(startingUnits2, "CoveredWagon", 3, 10.0);
   rmAddObjectDefItem(startingUnits2, "ypBankWagon", 1, 10.0);
   rmAddObjectDefItem(startingUnits2, "YPGroveWagon", 1, 10.0);
   rmSetObjectDefMinDistance(startingUnits2, 8.0);
   rmSetObjectDefMaxDistance(startingUnits2, 15.0);
   rmAddObjectDefConstraint(startingUnits2, avoidAll2);
   rmAddObjectDefConstraint(startingUnits2, avoidImpassableLand);
   rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));

    int StartBerryBushID=rmCreateObjectDef("starting BerryBush");
    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 5.0);
    rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
    rmSetObjectDefMaxDistance(StartBerryBushID, 15.0);
    rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
    
    int StartGazelleID=rmCreateObjectDef("starting Gazelle");
    rmAddObjectDefItem(StartGazelleID, "ypNilgai", 3, 5.0);
    rmSetObjectDefMinDistance(StartGazelleID, 10.0);
    rmSetObjectDefMaxDistance(StartGazelleID, 15.0);
    rmAddObjectDefConstraint(StartGazelleID, avoidStartingUnitsSmall);
    rmAddObjectDefConstraint(StartGazelleID, avoidDeer);
    rmAddObjectDefConstraint(StartGazelleID, avoidAll);
    rmAddObjectDefConstraint(StartGazelleID, avoidSocket);
    rmAddObjectDefConstraint(StartGazelleID, avoidTradeRoute);
    rmAddObjectDefConstraint(StartGazelleID, avoidImpassableLand);

    int playerNuggetID=rmCreateObjectDef("player nugget");
    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
    rmSetObjectDefMinDistance(playerNuggetID, 30.0);
    rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
    rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
    // rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

    int waterFlagID=-1;
    
    for(i=1; <cNumberPlayers)
    {
        rmClearClosestPointConstraints();
        // Place starting units and a TC!
        rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(startingUnits2, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

        // Everyone gets one ore grouping close by.
        silverType = rmRandInt(1,10);
        playerGoldID = rmCreateObjectDef("player silver closer "+i);
        rmAddObjectDefItem(playerGoldID, "minegold", 1, 0.0);
        // rmAddGroupingToClass(playerGoldID, rmClassID("importantItem"));
        rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
        rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
        rmSetObjectDefMinDistance(playerGoldID, 15.0);
        rmSetObjectDefMaxDistance(playerGoldID, 20.0);
        rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

        // Placing starting Pronghorns...
        /*
        rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        */
        rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        
        // Placing starting trees...
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

        // Nuggets
        rmSetNuggetDifficulty(1, 1);
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        
    if(ypIsAsian(i) && rmGetNomadStart() == false)
      rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i), i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

        // Water flag
        waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        rmAddClosestPointConstraint(flagEdgeConstraint);
        rmAddClosestPointConstraint(flagVsFlag);
        rmAddClosestPointConstraint(flagLand);
        vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

        rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
        rmClearClosestPointConstraints();
    }

    // Text
   rmSetStatusText("",0.60);

    // A few smallish cliffs on the northwest side (inland)
    /*DAL Temp - take these suckers out, now that there are some lakes
    int numTries=cNumberNonGaiaPlayers;
    int failCount=0;
    for(i=0; <numTries)
    {
        int cliffID=rmCreateArea("cliff "+i);
        rmSetAreaSize(cliffID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
        rmSetAreaWarnFailure(cliffID, false);
        rmSetAreaCliffType(cliffID, "SPC Caribbean");
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); // Attempt to keep cliffs away from each other.

        // rmSetAreaCliffEdge(cliffID, 1, 0.6, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(cliffID, 1, 1);
        rmSetAreaCliffPainting(cliffID, true, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliffID, 1.0);
        rmAddAreaTerrainLayer(cliffID, "andes\ground07_and", 0, 2);

        rmAddAreaConstraint(cliffID, avoidCliffs);              // Avoid other cliffs, please!
        rmAddAreaConstraint(cliffID, avoidImportantItem);
        rmAddAreaConstraint(cliffID, avoidTradeRoute);
        rmAddAreaConstraint(cliffID, avoidWater20);
        rmAddAreaConstraint(cliffID, Northwestward);                // Cliff are on the northwest side of the map.
        rmSetAreaSmoothDistance(cliffID, 10);
        rmSetAreaCoherence(cliffID, 0.25);

        if(rmBuildArea(cliffID)==false)
        {
            // Stop trying once we fail 3 times in a row
            failCount++;
            if(failCount==3)
                break;
        }
        else
            failCount=0;
    }
    */
   
   // Define and place Nuggets
    int nuggetID= rmCreateObjectDef("nugget"); 
    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
    rmSetObjectDefMinDistance(nuggetID, 0.0);
    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
    rmAddObjectDefConstraint(nuggetID, shortAvoidImpassableLand);
    rmAddObjectDefConstraint(nuggetID, avoidNugget);
    rmAddObjectDefConstraint(nuggetID, avoidStartingUnits);
    rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
    rmAddObjectDefConstraint(nuggetID, avoidSocket);
    rmAddObjectDefConstraint(nuggetID, avoidAll);
    rmAddObjectDefConstraint(nuggetID, avoidWater20);
    rmAddObjectDefConstraint(nuggetID, circleConstraint);
    rmSetNuggetDifficulty(2, 3);
    rmPlaceObjectDefInArea(nuggetID, 0, bigContinentID, cNumberNonGaiaPlayers*5);


   // fish
   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 20.0);
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
   int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 25.0);
   int whaleVsWhale2ID=rmCreateTypeDistanceConstraint("whale v whale", "humpbackWhale", 25.0);


   int playerFishID=rmCreateObjectDef("player fish");
   rmAddObjectDefItem(playerFishID, "FishCod", 1, 10.0);
   rmSetObjectDefMinDistance(playerFishID, 0.0);
   rmSetObjectDefMaxDistance(playerFishID, 20.0);
   rmAddObjectDefConstraint(playerFishID, fishVsFishID);
   rmAddObjectDefConstraint(playerFishID, fishLand);

   // rmPlaceObjectDefPerPlayer(playerFishID, false);

   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, "FishCod", 2, 5.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.0, cNumberNonGaiaPlayers*5);

    // FAST COIN -- WHALES
    int whaleID=rmCreateObjectDef("whale");
   rmAddObjectDefItem(whaleID, "humpbackWhale", 1, 9.0);
   rmSetObjectDefMinDistance(whaleID, 0.0);
   rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
   rmAddObjectDefConstraint(whaleID, whaleVsWhale2ID);
   rmAddObjectDefConstraint(whaleID, whaleLand);
   rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);


    //CARAVEL
   /*
   int colonyShipID = 0;
   for(i=1; <cNumberPlayers)
   {
        colonyShipID=rmCreateObjectDef("colony ship "+i);

        rmAddObjectDefItem(colonyShipID, "HomeCityWaterSpawnFlag", 1, 5.0);

        rmAddObjectDefConstraint(colonyShipID, shipVsShip);
        rmAddObjectDefConstraint(colonyShipID, fishLand);
        // rmAddObjectDefConstraint(colonyShipID, Southeastward);
        rmSetObjectDefMinDistance(colonyShipID, 0.0);
        rmSetObjectDefMaxDistance(colonyShipID, rmXFractionToMeters(0.3));

        // Ship placement
        if ( rmGetPlayerTeam(i) == 0 )
        {
            rmPlaceObjectDefAtLoc(colonyShipID, i, 0.0, 0.0, 1);
        }
        else
        {
            rmPlaceObjectDefAtLoc(colonyShipID, i, 1.0, 0.0, 1);
        }
        // vector colonyShipLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(colonyShipID, i));
        // rmSetHomeCityWaterSpawnPoint(i, colonyShipLocation);
    }
    */

   // Text
   rmSetStatusText("",0.65); 
 
   // Place resources that we want forests to avoid
    // Fast Coin
    int silverID = -1;
    int silverCount = cNumberNonGaiaPlayers*3;  // 3 per player, plus starting one.
    rmEchoInfo("silver count = "+silverCount);

    for(i=0; < silverCount)
    {
        silverType = rmRandInt(1,10);
        silverID = rmCreateObjectDef("silver "+i);
        rmAddObjectDefItem(silverID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(silverID, 0.0);
        rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));

        rmAddObjectDefConstraint(silverID, avoidFastCoin);
        rmAddObjectDefConstraint(silverID, avoidCoin);
        rmAddObjectDefConstraint(silverID, avoidAll);
        rmAddObjectDefConstraint(silverID, avoidImpassableLand);
        rmAddObjectDefConstraint(silverID, avoidTradeRoute);
        rmAddObjectDefConstraint(silverID, avoidSocket);
        rmAddObjectDefConstraint(silverID, avoidStartingUnits);
        // Keep silver away from the water, to avoid the art problem with the "cliffs."
        rmAddObjectDefConstraint(silverID, avoidWater30);
        rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }

    // FORESTS
   int forestTreeID = 0;
   int numTries=6*cNumberNonGaiaPlayers;
   int failCount=0;

   for (i=0; <numTries)
   {   
      int forest=rmCreateArea("forest "+i, rmAreaID("big continent"));
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(200), rmAreaTilesToFraction(250));
      rmSetAreaForestType(forest, "Caribbean Palm Forest");
      rmSetAreaForestDensity(forest, 1.0);
      rmSetAreaForestClumpiness(forest, 0.9);
      rmSetAreaForestUnderbrush(forest, 0.0);
      rmSetAreaCoherence(forest, 0.4);
      rmSetAreaSmoothDistance(forest, 10);
      rmAddAreaToClass(forest, rmClassID("classForest")); 
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidAll);
      rmAddAreaConstraint(forest, avoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);
      rmAddAreaConstraint(forest, avoidStartingUnits);
      rmAddAreaConstraint(forest, avoidImportantItem);
        rmAddAreaConstraint(forest, avoidSocket);
      if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         failCount=0; 
   } 
 
   // Text
   rmSetStatusText("",0.70);

    // DEER
   int deerID=rmCreateObjectDef("deer herd");
    int bonusChance=rmRandFloat(0, 1);
   
    if(bonusChance<0.5)
      rmAddObjectDefItem(deerID, "ypWildElephant", rmRandInt(3,5), 4.0);
   else
      rmAddObjectDefItem(deerID, "ypWildElephant", rmRandInt(3,5), 4.0);

   rmSetObjectDefMinDistance(deerID, 0.0);
   rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(deerID, avoidDeer);
    rmAddObjectDefConstraint(deerID, avoidAll);
    rmAddObjectDefConstraint(deerID, avoidSocket);
    rmAddObjectDefConstraint(deerID, avoidTradeRoute);
   rmAddObjectDefConstraint(deerID, avoidImpassableLand);
      rmAddObjectDefConstraint(deerID, avoidStartingUnits);
    rmSetObjectDefCreateHerd(deerID, true);
    rmPlaceObjectDefInArea(deerID, 0, bigContinentID, cNumberNonGaiaPlayers*5);
      
    // Text
   rmSetStatusText("",0.80);

    int sheepID=rmCreateObjectDef("ypgoat");
    rmAddObjectDefItem(sheepID, "ypgoat", 2, 4.0);
    rmSetObjectDefMinDistance(sheepID, 0.0);
    rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
    rmAddObjectDefConstraint(sheepID, avoidSheep);
    rmAddObjectDefConstraint(sheepID, avoidGoat);
    rmAddObjectDefConstraint(sheepID, avoidAll);
    rmAddObjectDefConstraint(sheepID, avoidSocket);
    rmAddObjectDefConstraint(sheepID, avoidTradeRoute);
    rmAddObjectDefConstraint(sheepID, longPlayerConstraint);
    rmAddObjectDefConstraint(sheepID, avoidCliffs);
    rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
    rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);

    // Large decorations - cut for now.
    int bigDecorationID=rmCreateObjectDef("Big New England Things");
    int avoidBigDecoration=rmCreateTypeDistanceConstraint("avoid big decorations", "GroundPropsAm", 12.0);
    rmAddObjectDefItem(bigDecorationID, "GroundPropsAm", 1, 0.0);
    rmSetObjectDefMinDistance(bigDecorationID, 0.0);
    rmSetObjectDefMaxDistance(bigDecorationID, rmXFractionToMeters(0.5));
    rmAddObjectDefConstraint(bigDecorationID, avoidAll);
    rmAddObjectDefConstraint(bigDecorationID, avoidImpassableLand);
    rmAddObjectDefConstraint(bigDecorationID, avoidBigDecoration);
    // rmPlaceObjectDefInArea(bigDecorationID, 0, bigContinentID, cNumberNonGaiaPlayers*2);

balanceVanilla();  
  
    // Starter shipment triggers
  for(i = 1; < cNumberPlayers) {
    rmCreateTrigger("XP"+i);
    rmSwitchToTrigger(rmTriggerID("XP"+i));
    rmSetTriggerPriority(3); 
    rmSetTriggerActive(true);
    rmSetTriggerRunImmediately(true);
    rmSetTriggerLoop(false);
      
    rmAddTriggerCondition("Always");
    
    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "XP", false);
    rmSetTriggerEffectParam("Amount", "10000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Trade", false);
    rmSetTriggerEffectParam("Amount", "5000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Food", false);
    rmSetTriggerEffectParam("Amount", "25000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Wood", false);
    rmSetTriggerEffectParam("Amount", "15000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Gold", false);
    rmSetTriggerEffectParam("Amount", "15000", false);
  } 	
  
  // Water nuggets
  
  int nuggetW= rmCreateObjectDef("nugget water"); 
  rmAddObjectDefItem(nuggetW, "ypNuggetBoat", 1, 0.0);
  rmSetNuggetDifficulty(5, 5);
  rmSetObjectDefMinDistance(nuggetW, rmXFractionToMeters(0.0));
  rmSetObjectDefMaxDistance(nuggetW, rmXFractionToMeters(0.5));
  rmAddObjectDefConstraint(nuggetW, avoidLand);
  rmAddObjectDefConstraint(nuggetW, avoidNuggetWater);
  rmAddObjectDefConstraint(nuggetW, nuggetVsFlag);
  rmPlaceObjectDefAtLoc(nuggetW, 0, 0.1, 0.1, cNumberNonGaiaPlayers*2);
  rmPlaceObjectDefAtLoc(nuggetW, 0, 0.1, 0.9, cNumberNonGaiaPlayers*2);
  rmPlaceObjectDefAtLoc(nuggetW, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	
   // Text
   rmSetStatusText("",0.9);
   
   // check for KOTH game mode
  if(rmGetIsKOTH()) {
    
    int randLoc = rmRandInt(1,2);
    float xLoc = 0.5;
    float yLoc = 0.9;
    float walk = 0.075;
    
    if(randLoc == 1 || cNumberTeams > 2)
      yLoc = .3;
    
    ypKingsHillPlacer(xLoc, yLoc, walk, 0);
    rmEchoInfo("XLOC = "+xLoc);
    rmEchoInfo("XLOC = "+yLoc);
  }

    // Silly Rock Walls can get placed last.  May not place at all...
    int stoneWallType = -1;
    int stoneWallID = -1;
    int stoneWallCount = cNumberNonGaiaPlayers*2;   
    rmEchoInfo("stoneWall count = "+stoneWallCount);

    for(i=0; < stoneWallCount)
    {
        stoneWallType = rmRandInt(1,4);
      stoneWallID = rmCreateGrouping("stone wall "+i, "ne_rockwall "+stoneWallType);
        rmAddGroupingToClass(stoneWallID, rmClassID("classWall"));
      rmSetGroupingMinDistance(stoneWallID, 0.0);
      rmSetGroupingMaxDistance(stoneWallID, rmXFractionToMeters(0.5));
        rmAddGroupingConstraint(stoneWallID, avoidFastCoin);
        rmAddGroupingConstraint(stoneWallID, avoidImpassableLand);
        rmAddGroupingConstraint(stoneWallID, avoidTradeRoute);
        rmAddGroupingConstraint(stoneWallID, avoidSocket);
        rmAddGroupingConstraint(stoneWallID, wallConstraint);
        rmAddGroupingConstraint(stoneWallID, avoidWater20);
        rmAddGroupingConstraint(stoneWallID, avoidStartingUnits);
        rmPlaceGroupingAtLoc(stoneWallID, 0, 0.5, 0.5);
   }
}
