// Painted Desert
// Jan 2006
// Dec 06 - YP update
// Main entry point for random map script
include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//Balance Start

/*
An attempt to fix only the biggest flaws in AOE 3 Vanilla Balance
Using only Scenario Triggers inside the Random Map Scripts for maximum compatibility
Draws some Ideas from the Community ESOC for TAD
and took some changes from the Asian Dynasties
Original Idea by Rikikipu: https://eso-community.net/viewtopic.php?t=6550
This Version fixes some remaining issues with Cards and Tech not taking changes into consideration
and adds some additional Balance Changes

Changes:
1. Halb -10 Food and Gold Cost, Ruyters -5 food, -5 gold 
2. TP -50 Wood Cost(from the Asian Dynasties)
3. Cuirassier -25 Base HP and -5 Gold and -5 Food Cost
4. Oprichnik -25 Base HP and +30 Food Cost, Strelet -5s train time
5. Indian Rajputs -20 wood, Mahouts -50 food and -50 wood, Gurkha -10 gold, +20 HP, Urumi Enabled
6. Monitor Cost decreased by 200 Gold
7. Ports start the game with +50 Wood
8. Tomahawks -25 food, Kanya Horsemen -25 wood, Mantlets -25 wood
9. Ashigarus +10 gold, +5s train time, -1 speed, Yabusames -20 gold, Samurai -10 Food and Gold, +10 HP, -1s train time
10. Dog Soldiers -40s train time, Skull Knights -30s train time
11. Iroquois Travois -15s train time, Medicine Men -15s train time, Warrior Priests -10s train time
12. Heavy Cannons, Great Bombards, Rockets +100 HP, Gatling Guns +50 HP
13. Outposts, Warhuts, Nobles Huts, Blockhosues +7 Build limit, Castles +5 Build limit

*/

void balanceVanilla(void)
{
for(i=1; <cNumberPlayers)
{	
	rmCreateTrigger("OverallBalance"+i);
    rmSwitchToTrigger(rmTriggerID("OverallBalance"+i));
	rmAddTriggerCondition("Timer");
    rmSetTriggerPriority(3);
    rmSetTriggerActive(true);
    rmSetTriggerRunImmediately(true);
    rmSetTriggerLoop(false);   
	rmSetTriggerConditionParamInt("Param1", 3);	
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "Factory");
    rmSetTriggerEffectParamInt("PlayerID", i);
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "ypBankAsian");
    rmSetTriggerEffectParamInt("PlayerID", i);
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "ypGroveBuilding");
    rmSetTriggerEffectParamInt("PlayerID", i);
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "CWallGate");
    rmSetTriggerEffectParamInt("PlayerID", i);
		
    rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "TradingPost");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 16);
    rmSetTriggerEffectParamInt("Delta", -100);
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Monitor");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 15);
    rmSetTriggerEffectParamInt("Delta", -200);	
		
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Cannon");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", 0);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "GreatBombard");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", 0);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Rocket");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", 0);	
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Cannon");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "GreatBombard");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Rocket");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpGatlingGun");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 50);	
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "ypConsulateCannon");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "ypConsulateGreatBombard");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "TownCenter");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 5);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "Outpost");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "ypCastle");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 5);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "WarHut");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "NoblesHut");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "Blockhouse");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "CoveredWagon");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
	rmSetTriggerEffectParamInt("Delta", 100);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "FortWagon");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
	rmSetTriggerEffectParamInt("Delta", 100);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "FactoryWagon");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
	rmSetTriggerEffectParamInt("Delta", 100);

	if ( rmGetPlayerCiv(i) == 3	){
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Cuirassier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Cuirassier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Cuirassier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
	}
	
	if ( rmGetPlayerCiv(i) == 21	){
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -150);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRajput");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -20);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypNatMercGurkha");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypNatMercGurkha");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypSepoy");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", -0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMercFlailiphant");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 1);
		rmSetTriggerEffectParamInt("Delta", 1);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRajput");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -5);
	}
	
	if ( rmGetPlayerCiv(i) == 3
	|| rmGetPlayerCiv(i) == 4
	|| rmGetPlayerCiv(i) == 5
	|| rmGetPlayerCiv(i) == 1
	){
	
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Ruyter");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Ruyter");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -5);
	}
	
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("Portuguese")){
      rmCreateTrigger("Wood babe"+i);
      rmSwitchToTrigger(rmTriggerID("Wood babe"+i));
      rmSetTriggerPriority(3); 
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);
      rmAddTriggerCondition("Always");
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmSetTriggerEffectParam("ResName", "Wood", false);
      rmSetTriggerEffectParam("Amount", "50", false);
    }	

	if ( rmGetPlayerCiv(i) == rmGetCivID("XPSioux")){
		//Uhlan 35s +5 +4
		//WarWagon 60 +9 +6
	
	rmCreateTrigger("DogTrainTime"+i);
		rmSwitchToTrigger(rmTriggerID("DogTrainTime"+i));
		rmSetTriggerPriority(3);
		rmSetTriggerActive(true);
		rmSetTriggerRunImmediately(false);
		rmSetTriggerLoop(false); 
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpDogSoldier");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -40);
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpMedicineMan");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -15);
	}
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("XPAztec")){
		//Uhlan 35s +5 +4
		//WarWagon 60 +9 +6
	
	rmCreateTrigger("SkullTrainTime"+i);
		rmSwitchToTrigger(rmTriggerID("SkullTrainTime"+i));
		rmSetTriggerPriority(3);
		rmSetTriggerActive(true);
		rmSetTriggerRunImmediately(false);
		rmSetTriggerLoop(false); 
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpSkullKnight");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -25);
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpMedicineManAztec");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -10);
	}
	
	if ( rmGetPlayerCiv(i) == 6	){
	
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -8);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Oprichnik");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 30);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Oprichnik");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Strelet");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -5);
	}
	
	if ( rmGetPlayerCiv(i) == 19	){
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypAshigaru");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypYabusame");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -20);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -1);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypAshigaru");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", 1);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypShrineJapanese");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 10);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypAshigaru");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 1);
		rmSetTriggerEffectParamInt("Delta", -1);
	}
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("XPIroquois")){
		//Uhlan 35s +5 +4
		//WarWagon 60 +9 +6
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpTomahawk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpMantlet");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpBuilder");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -15);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpMedicineMan");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -15);
	}

	if ( rmGetPlayerCiv(i) == rmGetCivID("Dutch")){
		//Settler +25
		//Dutch +50%
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Settler");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 10);
		rmSetTriggerEffectParamInt("Delta", 15);
	}
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("XPSioux")){
		//Axe Rider -40 Food
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpAxeRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -40);
	}

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -6);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -6);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);

		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -3);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantSmuggler");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -3);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantSmuggler");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
	
}
}
//Balance Ende
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx 

void main(void)
{
   // Text
   // These status text lines are used to manually animate the map generation progress bar
   rmSetStatusText("",0.01);

// ***************** CHOOSE NATIVES ******************
   int subCiv0=-1;
   int subCiv1=-1;
   int subCiv2=-1;
   int subCiv3=-1;

   
   int nativeMix=rmRandInt(0,1);
   
   if (rmAllocateSubCivs(4) == true)
   {
        
        if (nativeMix <= 0.5)
        {
       
            // Apache Outside, Navajo Inside.
            subCiv0=rmGetCivID("Incas");
            if (subCiv0 >= 0)
                rmSetSubCiv(0, "Incas");

            subCiv3=rmGetCivID("Incas");
            if (subCiv3 >= 0)
                rmSetSubCiv(3, "Incas");

            subCiv1=rmGetCivID("Comanche");
            if (subCiv1 >= 0)
                rmSetSubCiv(1, "Comanche");

            subCiv2=rmGetCivID("Comanche");
            if (subCiv2 >= 0)
                rmSetSubCiv(2, "Comanche");
        }
        else
        {
            // Navajo Outside, Apache Inside.
            subCiv0=rmGetCivID("Incas");
            if (subCiv0 >= 0)
                rmSetSubCiv(0, "Incas");

            subCiv3=rmGetCivID("Incas");
            if (subCiv3 >= 0)
                rmSetSubCiv(3, "Incas");

            subCiv1=rmGetCivID("Comanche");
            if (subCiv1 >= 0)
                rmSetSubCiv(1, "Comanche");

            subCiv2=rmGetCivID("Comanche");
            if (subCiv2 >= 0)
                rmSetSubCiv(2, "Comanche");

        }

   }
// ********************* MAP PARAMETERS ************************
	// Picks the map size
	//  int playerTiles=10000; old setting
	int playerTiles = 8000;
	if (cNumberNonGaiaPlayers >4)
		playerTiles = 9000;
	if (cNumberNonGaiaPlayers >6)
		playerTiles = 10000;		
/*
	if(cMapSize == 1)
	{
      playerTiles = 18000;
      rmEchoInfo("Large map");
	}
*/

	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);

	// rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	rmSetMapElevationParameters(cElevTurbulence, 0.02, 5, 0.7, 8.0);
	rmSetMapElevationHeightBlend(1);

	// Picks a default water height
	rmSetSeaLevel(4.0);

    // Picks default terrain and water
	rmSetSeaType("Amazon River");


	//float terrainPicker = rmRandFloat(0.0, 1.0);
	//if (terrainPicker <= 0.5)
	//{
		rmSetBaseTerrainMix("sonora_dirt");
	//}
	//else
	//{
	//	rmSetBaseTerrainMix("sonora_dirt");
	//}

	rmTerrainInitialize("california\desert2_cal", 4.0);
	rmSetMapType("SouthAfrica");
	rmSetMapType("Deccan");
	rmSetMapType("Borneo");
	rmSetMapType("desert");
	rmSetMapType("land");
	rmSetLightingSet("berlin dusk");

	// Choose mercs.
	chooseMercs();

	// Corner constraint.
	rmSetWorldCircleConstraint(true);

	int classPlayer=rmDefineClass("player");
	rmDefineClass("classHill");
	rmDefineClass("classPatch");
	rmDefineClass("starting settlement");
	rmDefineClass("startingUnit");
	rmDefineClass("classForest");
	rmDefineClass("importantItem");
	rmDefineClass("natives");
	rmDefineClass("classCliff");
	rmDefineClass("secrets");
	rmDefineClass("classNugget");
	rmDefineClass("center");
	int canyon=rmDefineClass("canyon");

	int avoidVultures=rmCreateTypeDistanceConstraint("avoids Vultures", "PropVulturePerching", 40.0);
	int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 35.0);
	int shortAvoidCanyons=rmCreateClassDistanceConstraint("short avoid canyons", rmClassID("canyon"), 15.0);
	int avoidNatives=rmCreateClassDistanceConstraint("avoid natives", rmClassID("natives"), 15.0);
	int avoidSilver=rmCreateTypeDistanceConstraint("gold avoid gold", "Mine", 55.0);
	int shortAvoidSilver=rmCreateTypeDistanceConstraint("short gold avoid gold", "Mine", 20.0);
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 4.0);
	int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), rmXFractionToMeters(0.23));
	int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), rmXFractionToMeters(0.10));
	int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 50.0);
	int shortForestConstraint=rmCreateClassDistanceConstraint("short forest vs. forest", rmClassID("classForest"), 10.0);
	int mediumForestConstraint=rmCreateClassDistanceConstraint("medium forest vs. forest", rmClassID("classForest"), 25.0);
	int avoidCow=rmCreateTypeDistanceConstraint("cow avoids cow", "cow", 40.0);
	int shortAvoidImportantItem=rmCreateClassDistanceConstraint("short avoid important", rmClassID("importantItem"), 5.0);

	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
	int avoidAll2=rmCreateTypeDistanceConstraint("avoid all", "all", 2.0);
	int avoidImpassableLand2=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);

	int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	int avoidBuzzards=rmCreateTypeDistanceConstraint("buzzard avoid buzzard", "BuzzardFlock", 70.0);
	int avoidBison=rmCreateTypeDistanceConstraint("avoid Bison", "Bison", 25);
	int avoidNilgai=rmCreateTypeDistanceConstraint("avoid Bison", "ypNilgai", 25);
	int avoidPronghorn=rmCreateTypeDistanceConstraint("avoid Pronghorn", "Pronghorn", 25);
	int avoidTradeRoute=rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
	int longPlayerConstraint=rmCreateClassDistanceConstraint("long stay away from players", classPlayer, 40.0);
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
	int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 20.0);
	int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players short", classPlayer, 8.0);
	int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 45.0);
	int shortAvoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget short", rmClassID("classNugget"), 8.0);
	int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid Trade Socket", "sockettraderoute", 10);
	int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
	int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
	int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

		
// starting resources

	int TCID = rmCreateObjectDef("player TC");
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	}
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 10.0);
	rmAddObjectDefConstraint(TCID, avoidTradeRoute);
	rmAddObjectDefToClass(TCID, rmClassID("player"));
	rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));

	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	rmSetObjectDefMinDistance(startingUnits, 8.0);
	rmSetObjectDefMaxDistance(startingUnits, 12.0);
	rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(startingUnits, avoidStartingUnits);
	
   int startingUnits2 = rmCreateObjectDef("extra units");
   rmAddObjectDefItem(startingUnits2, "CoveredWagon", 3, 10.0);
   rmAddObjectDefItem(startingUnits2, "ypBankWagon", 1, 10.0);
   rmAddObjectDefItem(startingUnits2, "YPGroveWagon", 1, 10.0);
   rmSetObjectDefMinDistance(startingUnits2, 8.0);
   rmSetObjectDefMaxDistance(startingUnits2, 15.0);
   rmAddObjectDefConstraint(startingUnits2, avoidAll2);
   rmAddObjectDefConstraint(startingUnits2, avoidImpassableLand2);
   rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));

	int playerSilverID = rmCreateObjectDef("player silver");
	rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	rmSetObjectDefMinDistance(playerSilverID, 20.0);
	rmSetObjectDefMaxDistance(playerSilverID, 25.0);
	//rmAddObjectDefConstraint(playerSilverID, avoidAll);
	rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerSilverID, avoidStartingUnits);

	int StartAreaTreeID=rmCreateObjectDef("starting trees");
	rmAddObjectDefItem(StartAreaTreeID, "TreePaintedDesert", rmRandInt(9,10), 4.0);
	// rmAddObjectDefItem(StartAreaTreeID, "UnderbrushDesert", rmRandInt(4,6), 4.0);
	rmSetObjectDefMinDistance(StartAreaTreeID, 9);
	rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(StartAreaTreeID, avoidImpassableLand);
	//rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidSilver);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnits);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidResource);


 
//   ----------------------------Bison Herd-----------------------------------

	int startBisonID = rmCreateObjectDef("starting bison");
	rmAddObjectDefItem(startBisonID, "ypNilgai", rmRandInt(7,9), 8.0);
	rmSetObjectDefCreateHerd(startBisonID, true);
	rmSetObjectDefMinDistance(startBisonID, 16);
	rmSetObjectDefMaxDistance(startBisonID, 20);
	rmAddObjectDefToClass(startBisonID, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(startBisonID, avoidImpassableLand);
	rmAddObjectDefConstraint(startBisonID, shortAvoidImportantItem);
	// rmAddObjectDefConstraint(startBisonID, avoidTradeRoute);
	rmAddObjectDefConstraint(startBisonID, avoidStartingUnits);
	rmAddObjectDefConstraint(startBisonID, avoidResource);

	
//-----------------------------------------------------------------------------
//


// --> TCID, startingUnits, playerSilverID, StartAreaTreeID and StartTurkeyID all added to rmClassID("startingUnit")
	
// Text
	rmSetStatusText("",0.2);


	int canyonConstraint=rmCreateClassDistanceConstraint("canyons start away from each other", canyon, 5.0);

	int failCount=0;
	int numTries=cNumberNonGaiaPlayers*15;


		// ****************************** PLACE PLAYERS *********************

	int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	int teamOneCount = rmGetNumberPlayersOnTeam(1);
// 2 team and FFA support
	float OneVOnePlacement=rmRandFloat(0, 1);
	if (cNumberNonGaiaPlayers == 2)
	{
		if ( OneVOnePlacement < 0.5)
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.2, 0.4, 0.2, 0.6, 0, 0.05);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.8, 0.4, 0.8, 0.6, 0, 0.05);
		}
		else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.8, 0.4, 0.8, 0.6, 0, 0.05);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.2, 0.4, 0.2, 0.6, 0, 0.05);
		}
	}
	else if ( cNumberTeams <= 2 && teamZeroCount <= 4 && teamOneCount <= 4)
	{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.6, 0.85); // 0.5   KSW ---> Was (0.35, 0.6)
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersCircular(0.38, 0.40, 0);

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.1, 0.35); // 0.5  KSW ---> Was (0.85, 0.10)
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersCircular(0.38, 0.40, 0);
	}
	else
	{	
		rmSetTeamSpacingModifier(0.7);
		rmPlacePlayersCircular(0.42, 0.44, 0.0);
	}



		 // Build an invisible "west desert" area.
		int westDesertID = rmCreateArea("west desert");
		rmSetAreaLocation(westDesertID, 0.45, 1.0); 
		rmSetAreaWarnFailure(westDesertID, false);
		rmSetAreaSize(westDesertID, 0.2, 0.2);
		rmSetAreaCoherence(westDesertID, 0.5);
		// rmAddAreaInfluenceSegment(westDesertID, 0.45, 0.1, 0., 0.9);
		rmSetAreaTerrainType(westDesertID, "texas\ground4_tex");
        rmAddAreaTerrainLayer(westDesertID, "california\desert2_cal", 0, 4);
        rmAddAreaTerrainLayer(westDesertID, "california\desert3_cal", 4, 10);
        rmAddAreaTerrainLayer(westDesertID, "california\desert4_cal", 10, 16);
		rmSetAreaObeyWorldCircleConstraint(westDesertID, false);
		rmSetAreaMix(westDesertID, "sonora_dirt");
		rmBuildArea(westDesertID);
	

	
	
	// ----------------------- *** Set up player areas *** ---------------------


	float playerFraction=rmAreaTilesToFraction(120);   //KSW ---> Was 100
	for(i=1; <cNumberPlayers)
	{
		// Create the area.
		int id=rmCreateArea("Player"+i);
		// Assign to the player.
		rmSetPlayerArea(i, id);
		// Set the size.
		rmSetAreaSize(id, playerFraction, playerFraction);
		rmAddAreaToClass(id, classPlayer);
		rmSetAreaMinBlobs(id, 1);
		rmSetAreaMaxBlobs(id, 1);
		//  rmAddAreaConstraint(id, playerConstraint); 
		//  rmAddAreaConstraint(id, playerEdgeConstraint); 
		rmSetAreaLocPlayer(id, i);

		rmSetAreaMix(id, "kalahari_dirt");  //KSW ---> Was groundmix_2
		rmSetAreaWarnFailure(id, false);
	}
	// Build the areas.
   rmBuildAllAreas();


   
 /*
   
   // ******************************* PLACE BIG MESA ****************************


	int bigMesaID = rmCreateObjectDef("large mesa"); 
	rmAddObjectDefItem(bigMesaID, "BigPropPaintedDesert", 1, 0);
																					//<--- Mesa Looks Weird ************
	rmSetObjectDefMinDistance(bigMesaID, 0.0);
	rmSetObjectDefMaxDistance(bigMesaID, 0.0);
	rmAddObjectDefToClass(bigMesaID, rmClassID("importantItem"));
	rmPlaceObjectDefAtLoc(bigMesaID, 0, 0.45, 0.9);


*/

//    *********************************** PLACE NATIVES *************************

	if (subCiv0 == rmGetCivID("Incas"))
    {  
        int apacheVillageID = -1;
        int apacheVillageType = rmRandInt(1,5);
        int randomPlacement = rmRandInt(1,10);
        apacheVillageID = rmCreateGrouping("apache village", "native inca village "+apacheVillageType);
        rmSetGroupingMinDistance(apacheVillageID, 0.0);
        rmSetGroupingMaxDistance(apacheVillageID, 20.0);
        rmAddGroupingConstraint(apacheVillageID, avoidImpassableLand);
        rmAddGroupingToClass(apacheVillageID, rmClassID("natives"));
        rmAddGroupingToClass(apacheVillageID, rmClassID("importantItem"));
            if (randomPlacement <= 8)
            rmPlaceGroupingAtLoc(apacheVillageID, 0, 0.45, 0.85);  //KSW ---> Was 0.82, 0.5
            else
            rmPlaceGroupingAtLoc(apacheVillageID, 0, 0.45, 0.83);
        
    }

    
    if (subCiv0 == rmGetCivID("Incas"))
    {  
        int navajoVillageID = -1;
        int navajoVillageType = rmRandInt(1,5);
        randomPlacement = rmRandInt(1,10);
        navajoVillageID = rmCreateGrouping("navajo village", "native inca village "+navajoVillageType);
        rmSetGroupingMinDistance(navajoVillageID, 0.0);
        rmSetGroupingMaxDistance(navajoVillageID, 20.0);
        rmAddGroupingConstraint(navajoVillageID, avoidImpassableLand);
        rmAddGroupingToClass(navajoVillageID, rmClassID("natives"));
        rmAddGroupingToClass(navajoVillageID, rmClassID("importantItem"));
            if (randomPlacement <= 8)
            rmPlaceGroupingAtLoc(navajoVillageID, 0, 0.45, 0.85);  //KSW ---> Was 0.82, 0.5
            else
            rmPlaceGroupingAtLoc(navajoVillageID, 0, 0.45, 0.83);
        
    }

    if (subCiv1 == rmGetCivID("Comanche"))
    {
        navajoVillageID = -1;
        navajoVillageType = rmRandInt(1,5);
        randomPlacement = rmRandInt(1,10);
        navajoVillageID = rmCreateGrouping("navajo village", "native comanche village "+navajoVillageType);
        rmSetGroupingMinDistance(navajoVillageID, 0.0);
        rmSetGroupingMaxDistance(navajoVillageID, 20.0);
        rmAddGroupingConstraint(navajoVillageID, avoidImpassableLand);
        rmAddGroupingToClass(navajoVillageID, rmClassID("natives"));
        
        if (randomPlacement <= 8)
            rmPlaceGroupingAtLoc(navajoVillageID, 0, 0.48, 0.6);
        else
            rmPlaceGroupingAtLoc(navajoVillageID, 0, 0.48, 0.63);
        
    }

    if (subCiv1 == rmGetCivID("Comanche"))
    {
        apacheVillageID = -1;
        apacheVillageType = rmRandInt(1,5);
        randomPlacement = rmRandInt(1,10);
        apacheVillageID = rmCreateGrouping("apache village", "native comanche village "+apacheVillageType);
        rmSetGroupingMinDistance(apacheVillageID, 0.0);
        rmSetGroupingMaxDistance(apacheVillageID, 20.0);
        rmAddGroupingConstraint(apacheVillageID, avoidImpassableLand);
        rmAddGroupingToClass(apacheVillageID, rmClassID("natives"));
        
        if (randomPlacement <= 8)
            rmPlaceGroupingAtLoc(apacheVillageID, 0, 0.48, 0.6);
        else
            rmPlaceGroupingAtLoc(apacheVillageID, 0, 0.48, 0.63);
        
    }

    if (subCiv2 == rmGetCivID("Comanche"))
    {
        navajoVillageID = -1;
        navajoVillageType = rmRandInt(1,5);
        randomPlacement = rmRandInt(1,10);
        navajoVillageID = rmCreateGrouping("navajo village2", "native comanche village "+navajoVillageType);
        rmSetGroupingMinDistance(navajoVillageID, 0.0);
        rmSetGroupingMaxDistance(navajoVillageID, 20.0);
        rmAddGroupingConstraint(navajoVillageID, avoidImpassableLand);
        rmAddGroupingToClass(navajoVillageID, rmClassID("natives"));
        
        if (randomPlacement <= 8)
            rmPlaceGroupingAtLoc(navajoVillageID, 0, 0.52, 0.4);
        else
            rmPlaceGroupingAtLoc(navajoVillageID, 0, 0.52, 0.33);
    }

    if (subCiv2 == rmGetCivID("Comanche"))
    {
        apacheVillageID = -1;
        apacheVillageType = rmRandInt(1,5);
        randomPlacement = rmRandInt(1,10);
        apacheVillageID = rmCreateGrouping("apache village2", "native comanche village "+apacheVillageType);
        rmSetGroupingMinDistance(apacheVillageID, 0.0);
        rmSetGroupingMaxDistance(apacheVillageID, 20.0);
        rmAddGroupingConstraint(apacheVillageID, avoidImpassableLand);
        rmAddGroupingToClass(apacheVillageID, rmClassID("natives"));
        
        if (randomPlacement <= 8)
            rmPlaceGroupingAtLoc(apacheVillageID, 0, 0.52, 0.4);
        else
            rmPlaceGroupingAtLoc(apacheVillageID, 0, 0.52, 0.33);
    }
    
    if (subCiv3 == rmGetCivID("Incas"))
    {
        navajoVillageID = -1;
        navajoVillageType = rmRandInt(1,5);
        randomPlacement = rmRandInt(1,10);
        navajoVillageID = rmCreateGrouping("navajo village2", "native inca village "+navajoVillageType);
        rmSetGroupingMinDistance(navajoVillageID, 0.0);
        rmSetGroupingMaxDistance(navajoVillageID, 20.0);
        rmAddGroupingConstraint(navajoVillageID, avoidImpassableLand);
        rmAddGroupingToClass(navajoVillageID, rmClassID("natives"));
        
        if (randomPlacement <= 8)
            rmPlaceGroupingAtLoc(navajoVillageID, 0, 0.55, 0.11);
        else
            rmPlaceGroupingAtLoc(navajoVillageID, 0, 0.55, 0.17);
        
    }

    if (subCiv3 == rmGetCivID("Incas"))
    {
        apacheVillageID = -1;
        apacheVillageType = rmRandInt(1,5);
        randomPlacement = rmRandInt(1,10);
        apacheVillageID = rmCreateGrouping("apache village2", "native inca village "+apacheVillageType);
        rmSetGroupingMinDistance(apacheVillageID, 0.0);
        rmSetGroupingMaxDistance(apacheVillageID, 20.0);
        rmAddGroupingConstraint(apacheVillageID, avoidImpassableLand);
        rmAddGroupingToClass(apacheVillageID, rmClassID("natives"));
        
        if (randomPlacement <= 8)
            rmPlaceGroupingAtLoc(apacheVillageID, 0, 0.55, 0.11);
        else
            rmPlaceGroupingAtLoc(apacheVillageID, 0, 0.55, 0.17);
        
    }



//**************************************** cliff embellishments *********************************************
	
	for(i=0; <numTries)
	{
		int cliffHeight=rmRandInt(3,6);     //KSW ---> Was 2, 8
		int mesaID=rmCreateArea("mesa"+i);
		rmSetAreaSize(mesaID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(70));  // used to be 300 KSW ---> Used to be 200
		rmSetAreaWarnFailure(mesaID, false);
		rmSetAreaCliffType(mesaID, "Texas Grass");
		rmAddAreaToClass(mesaID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(mesaID, 1, 1.0, 0.1, 1.0, 0);
		/*  if (cliffHeight <= 5)
		rmSetAreaCliffHeight(mesaID, rmRandInt(3,5), 1.0, 1.0);
		else */
		rmSetAreaCliffHeight(mesaID, rmRandInt(3,8), 1.0, 1.0);  // KSW --> digs into ground to make ditch. Now only grows up. Was (4, 10)
		rmAddAreaConstraint(mesaID, avoidCanyons);
		rmAddAreaConstraint(mesaID, avoidNatives);
		//rmSetAreaMinBlobs(mesaID, 3);
		//rmSetAreaMaxBlobs(mesaID, 5);
		//rmSetAreaMinBlobDistance(mesaID, 3.0);
		//rmSetAreaMaxBlobDistance(mesaID, 5.0);
		rmSetAreaCoherence(mesaID, 0.5);
		rmAddAreaConstraint(mesaID, playerConstraint); 
	//	rmAddAreaConstraint(mesaID, avoidTradeRouteSockets);
	//	rmAddAreaConstraint(mesaID, avoidTradeRoute);
		rmAddAreaConstraint(mesaID, shortAvoidSilver);
		rmAddAreaConstraint(mesaID, avoidStartingUnits);
		rmAddAreaConstraint(mesaID, shortAvoidImportantItem);  // Added New
		if(rmBuildArea(mesaID)==false)
		{
			// Stop trying once we fail 2 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	}

// Text
rmSetStatusText("",0.4);
	
	
// ------------------------- *** small cliffs ***--------------------------------------

	for(i=0; <numTries)
	{
		int smallCliffHeight=rmRandInt(0,5);
		int smallMesaID=rmCreateArea("small mesa"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(8), rmAreaTilesToFraction(12));  // used to be 300
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, "Texas Grass");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(6,8), 1.0, 1.0);
		//rmAddAreaConstraint(smallMesaID, shortAvoidCanyons);
		rmAddAreaConstraint (smallMesaID, avoidCanyons);
		//rmSetAreaMinBlobs(smallMesaID, 3);
		//rmSetAreaMaxBlobs(smallMesaID, 5);
		//rmSetAreaMinBlobDistance(smallMesaID, 3.0);
		//rmSetAreaMaxBlobDistance(smallMesaID, 5.0);
		rmSetAreaCoherence(smallMesaID, 0.6);
		rmAddAreaConstraint(smallMesaID, mediumPlayerConstraint); 
		rmAddAreaConstraint(smallMesaID, avoidNatives); 
	//	rmAddAreaConstraint(smallMesaID, avoidTradeRouteSockets);
	//	rmAddAreaConstraint(smallMesaID, avoidTradeRoute);
		rmAddAreaConstraint(smallMesaID, avoidStartingUnits);
		rmAddAreaConstraint(smallMesaID, shortAvoidSilver);
		rmAddAreaConstraint(smallMesaID, shortAvoidImportantItem);    // Added New
		if(rmBuildArea(smallMesaID)==false)
		{
			// Stop trying once we fail 10 times in a row.
			failCount++;
			if(failCount==6)   //KSW ---> Was 20
				break;
		}
		else
			failCount=0;
	}



// ---------------------- *** Place Players and Starting Units *** -------------------------------------------------------------------

	for(i=1; <cNumberPlayers)
	{
		
		// Test of Marcin's Starting Units stuff...
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits2, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	  //	rmPlaceObjectDefAtLoc(StartTurkeyID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
    
    vector TCLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
    
    if(ypIsAsian(i) && rmGetNomadStart() == false)
      rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
    
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		//vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		//rmSetHomeCityGatherPoint(i, closestPoint);
	}

// ------------------------------------------------------------------------------------------------------------------------------------	
	

// ************************************ FORESTS **************************************


	
	for(i=0; <cNumberNonGaiaPlayers*6)
	{
		int edgeForestID=rmCreateArea("edgeForest"+i);
		rmSetAreaWarnFailure(edgeForestID, false);
		rmSetAreaSize(edgeForestID, rmAreaTilesToFraction(140), rmAreaTilesToFraction(200));  // was 200 to 250
		rmSetAreaForestType(edgeForestID, "sonora forest");
		rmSetAreaForestDensity(edgeForestID, 20.0);                         //KSW --> Was 1.0
		rmSetAreaForestClumpiness(edgeForestID, 3.0);		
		rmSetAreaForestUnderbrush(edgeForestID, 0.0);
		rmAddAreaToClass(edgeForestID, rmClassID("classForest"));
		rmSetAreaMinBlobs(edgeForestID, 1);
		rmSetAreaMaxBlobs(edgeForestID, 3);					
		rmSetAreaMinBlobDistance(edgeForestID, 16.0);
		rmSetAreaMaxBlobDistance(edgeForestID, 30.0);
		rmSetAreaCoherence(edgeForestID, 0.4);
		rmSetAreaSmoothDistance(edgeForestID, 8);
		rmAddAreaConstraint(edgeForestID, shortPlayerConstraint);
		rmAddAreaConstraint(edgeForestID, forestConstraint); 
		rmAddAreaConstraint(edgeForestID, shortAvoidSilver);  
		rmAddAreaConstraint(edgeForestID, shortAvoidCanyons); 
	//	rmAddAreaConstraint(edgeForestID, avoidTradeRoute);
	//	rmAddAreaConstraint(edgeForestID, avoidTradeRouteSockets);
		rmAddAreaConstraint(edgeForestID, avoidStartingUnits);
		rmAddAreaConstraint(edgeForestID, avoidNatives);
		rmAddAreaConstraint(edgeForestID, shortAvoidImportantItem);  // Added New
			if(rmBuildArea(edgeForestID)==false)
			{
				// Stop trying once we fail 10 times in a row.  
				failCount++;
				if(failCount==24)
					break;
			}
			else
				failCount=0; 
	}
	

	// COIN RESOURCES

	int silverType = rmRandInt(1,10);   
	int silverID = -1;
	int silverCount = cNumberNonGaiaPlayers*4;	//KSW ---> Was number*3
	rmEchoInfo("silver count = "+silverCount);

	for(i=0; < silverCount)
	{
		silverID = rmCreateObjectDef("silver"+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.45));
		rmAddObjectDefConstraint(silverID, shortAvoidImpassableLand);
		rmAddObjectDefConstraint(silverID, canyonConstraint);
		rmAddObjectDefConstraint(silverID, avoidSilver);
		rmAddObjectDefConstraint(silverID, mediumPlayerConstraint);
		rmAddObjectDefConstraint(silverID, shortForestConstraint);
		rmAddObjectDefConstraint(silverID, avoidNatives);
		rmAddObjectDefConstraint(silverID, shortAvoidImportantItem);          // Added New
		//rmAddObjectDefConstraint(silverID, avoidTradeRouteSockets);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);

	}


// Text
	rmSetStatusText("",0.6);


// ------------------------------------- *** Random Trees *** ------------------------------------------------
	
	for(i=0; < 16*cNumberNonGaiaPlayers)  
	{
		int randomTreeID=rmCreateObjectDef("random tree "+i);
		rmAddObjectDefItem(randomTreeID, "TreePaintedDesert", rmRandInt(4,8), 3.0);
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
		rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.3));
		rmAddObjectDefConstraint(randomTreeID, avoidResource);
		//rmAddObjectDefConstraint(randomTreeID, shortAvoidImpassableLand);
		rmAddObjectDefConstraint(randomTreeID, avoidTradeRouteSockets);
		rmAddObjectDefConstraint(randomTreeID, shortPlayerConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidStartingUnits);
		rmAddObjectDefConstraint(randomTreeID, shortAvoidCanyons); 
		rmAddObjectDefConstraint(randomTreeID, shortAvoidImportantItem);				// Added New
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5);
   }




	// ************************************ TREASURES ***********************************

		int nugget1= rmCreateObjectDef("nugget easy"); 
		rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget1, rmClassID("classNugget"));
		rmAddObjectDefConstraint(nugget1, avoidResource);
		rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
	//	rmAddObjectDefConstraint(nugget1, avoidTradeRouteSockets);
	//	rmAddObjectDefConstraint(nugget1, avoidTradeRoute);

		rmAddObjectDefConstraint(nugget1, mediumPlayerConstraint);
		
		rmAddObjectDefConstraint(nugget1, avoidStartingUnits);
		rmAddObjectDefConstraint(nugget1, shortAvoidCanyons);
		rmAddObjectDefConstraint(nugget1, avoidNugget);
		rmAddObjectDefConstraint(nugget1, avoidNatives);
		rmAddObjectDefConstraint(nugget1, circleConstraint);
		rmAddObjectDefConstraint(nugget1, shortAvoidImportantItem);			// Added New
		rmSetObjectDefMinDistance(nugget1, 40.0);
		rmSetObjectDefMaxDistance(nugget1, 60.0);
		rmPlaceObjectDefPerPlayer(nugget1, false, cNumberNonGaiaPlayers*2);

		int nugget2= rmCreateObjectDef("nugget medium"); 
		rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
		rmAddObjectDefToClass(nugget2, rmClassID("classNugget"));
		rmSetObjectDefMinDistance(nugget2, 0.0);
		rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(nugget2, avoidResource);
		rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
	//	rmAddObjectDefConstraint(nugget2, avoidTradeRouteSockets);
	//	rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget2, mediumPlayerConstraint);
		rmAddObjectDefConstraint(nugget2, shortAvoidCanyons);
		rmAddObjectDefConstraint(nugget2, avoidStartingUnits);
		rmAddObjectDefConstraint(nugget2, avoidNugget);
		rmAddObjectDefConstraint(nugget2, avoidNatives);
		rmAddObjectDefConstraint(nugget2, circleConstraint);
		rmAddObjectDefConstraint(nugget2, shortAvoidImportantItem);				// Added New
		rmSetObjectDefMinDistance(nugget2, 80.0);
		rmSetObjectDefMaxDistance(nugget2, 120.0);
		rmPlaceObjectDefPerPlayer(nugget2, false, cNumberNonGaiaPlayers*2);

		int nugget3= rmCreateObjectDef("nugget hard"); 
		rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(3, 3);
		rmAddObjectDefToClass(nugget3, rmClassID("classNugget"));
		rmSetObjectDefMinDistance(nugget3, 0.0);
		rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.4));
		rmAddObjectDefConstraint(nugget3, avoidResource);
		rmAddObjectDefConstraint(nugget3, shortAvoidImpassableLand);
	//	rmAddObjectDefConstraint(nugget3, avoidTradeRouteSockets);
	//	rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget3, mediumPlayerConstraint);
		rmAddObjectDefConstraint(nugget3, shortAvoidCanyons);
		rmAddObjectDefConstraint(nugget3, avoidStartingUnits);
		rmAddObjectDefConstraint(nugget3, avoidNugget);
		rmAddObjectDefConstraint(nugget3, avoidNatives);
		rmAddObjectDefConstraint(nugget3, circleConstraint);
		rmAddObjectDefConstraint(nugget3, shortAvoidImportantItem);					// Added New
		rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);

		int nugget4= rmCreateObjectDef("nugget nuts"); 
		rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmAddObjectDefToClass(nugget4, rmClassID("classNugget"));
		rmSetObjectDefMinDistance(nugget4, 0.0);
		rmSetObjectDefMaxDistance(nugget4, rmXFractionToMeters(0.4));
		rmAddObjectDefConstraint(nugget4, avoidResource);
		rmAddObjectDefConstraint(nugget4, shortAvoidImpassableLand);
	//	rmAddObjectDefConstraint(nugget4, avoidTradeRouteSockets);
	//	rmAddObjectDefConstraint(nugget4, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget4, mediumPlayerConstraint);
		rmAddObjectDefConstraint(nugget4, shortAvoidCanyons);
		rmAddObjectDefConstraint(nugget4, avoidStartingUnits);
		rmAddObjectDefConstraint(nugget4, avoidNugget);
		rmAddObjectDefConstraint(nugget4, avoidNatives);
		rmAddObjectDefConstraint(nugget4, circleConstraint);
		rmAddObjectDefConstraint(nugget4, shortAvoidImportantItem);			// Added New
		rmPlaceObjectDefAtLoc(nugget4, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);

  // check for KOTH game mode
  if(rmGetIsKOTH()) {
    
    int randLoc = rmRandInt(1,2);
    float xLoc = 0.5;
    float yLoc = 0.5;
    float walk = 0.075;
    
    ypKingsHillPlacer(xLoc, yLoc, walk, 0);
    rmEchoInfo("XLOC = "+xLoc);
    rmEchoInfo("XLOC = "+yLoc);
  }


balanceVanilla();  
  
    // Starter shipment triggers
  for(i = 1; < cNumberPlayers) {
    rmCreateTrigger("XP"+i);
    rmSwitchToTrigger(rmTriggerID("XP"+i));
    rmSetTriggerPriority(3); 
    rmSetTriggerActive(true);
    rmSetTriggerRunImmediately(true);
    rmSetTriggerLoop(false);
      
    rmAddTriggerCondition("Always");
    
    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "XP", false);
    rmSetTriggerEffectParam("Amount", "10000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Trade", false);
    rmSetTriggerEffectParam("Amount", "5000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Food", false);
    rmSetTriggerEffectParam("Amount", "25000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Wood", false);
    rmSetTriggerEffectParam("Amount", "15000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Gold", false);
    rmSetTriggerEffectParam("Amount", "15000", false);
  } 
  
// Text
	rmSetStatusText("",0.8);
	
//------------------------ *** Place Cows *** ---------------------------------------

	int cowID=rmCreateObjectDef("cow");
	rmAddObjectDefItem(cowID, "cow", 2, 4.0);
	rmSetObjectDefMinDistance(cowID, 0.0);
	rmSetObjectDefMaxDistance(cowID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(cowID, avoidCow);
	// rmAddObjectDefConstraint(cowID, avoidAll);
	rmAddObjectDefConstraint(cowID, playerConstraint);
	rmAddObjectDefConstraint(cowID, shortAvoidCanyons);
	rmAddObjectDefConstraint(cowID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(cowID, shortAvoidNugget);
	rmAddObjectDefConstraint(cowID, shortAvoidImportantItem);					// Added New
	rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);


	// ----------------------- *** Place Bison Herds *** --------------------------------

	int bisonID=rmCreateObjectDef("Bison herd");
	rmAddObjectDefItem(bisonID, "ypNilgai", rmRandInt(5,7), 6.0);
	rmSetObjectDefCreateHerd(bisonID, true);
	rmSetObjectDefMinDistance(bisonID, 0.0);
	rmSetObjectDefMaxDistance(bisonID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(bisonID, avoidResource);
	// rmAddObjectDefConstraint(bisonID, centerConstraint);
	rmAddObjectDefConstraint(bisonID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(bisonID, avoidBison);
	rmAddObjectDefConstraint(bisonID, avoidNilgai);
	rmAddObjectDefConstraint(bisonID, avoidNatives);
	rmAddObjectDefConstraint(bisonID, avoidPronghorn);
	rmAddObjectDefConstraint(bisonID, shortAvoidNugget);
	rmAddObjectDefConstraint(bisonID, playerConstraint);
	rmAddObjectDefConstraint(bisonID, shortAvoidCanyons);
	rmAddObjectDefConstraint(bisonID, shortAvoidImportantItem);					// Added New
	// rmAddObjectDefConstraint(bisonID, avoidTradeRouteSockets);
	rmPlaceObjectDefAtLoc(bisonID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);


// --------------------------- *** Place Pronghorn Herds *** -------------------------------

	int pronghornID=rmCreateObjectDef("pronghorn herd");
	rmAddObjectDefItem(pronghornID, "ypNilgai", rmRandInt(6, 8), 6.0);
	rmSetObjectDefCreateHerd(pronghornID, true);
	rmSetObjectDefMinDistance(pronghornID, 0.0);
	rmSetObjectDefMaxDistance(pronghornID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(pronghornID, avoidResource);
	// rmAddObjectDefConstraint(pronghornID, centerConstraint);
	rmAddObjectDefConstraint(pronghornID, shortAvoidImpassableLand);		// TEMP fix to allow pronghorn to be placed
	// rmAddObjectDefConstraint(pronghornID, avoidImpassableLand);			// Problem Child
	rmAddObjectDefConstraint(pronghornID, avoidNatives);
	rmAddObjectDefConstraint(pronghornID, avoidPronghorn);
	rmAddObjectDefConstraint(pronghornID, avoidNilgai);
	rmAddObjectDefConstraint(pronghornID, shortAvoidNugget);
	rmAddObjectDefConstraint(pronghornID, playerConstraint);
	rmAddObjectDefConstraint(pronghornID, avoidBison);
	rmAddObjectDefConstraint(pronghornID, avoidStartingUnits);
	//rmAddObjectDefConstraint(pronghornID, shortAvoidCanyons);
	rmAddObjectDefConstraint(pronghornID, shortAvoidImportantItem);					// Added New
	// rmAddObjectDefConstraint(pronghornID, avoidTradeRouteSockets);
	rmPlaceObjectDefAtLoc(pronghornID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
	
	int buzzardFlockID=rmCreateObjectDef("buzzards");
	rmAddObjectDefItem(buzzardFlockID, "BuzzardFlock", 1, 3.0);
	rmSetObjectDefMinDistance(buzzardFlockID, 0.0);
	rmSetObjectDefMaxDistance(buzzardFlockID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(buzzardFlockID, avoidBuzzards);
	rmAddObjectDefConstraint(buzzardFlockID, avoidTradeRouteSockets);
	rmAddObjectDefConstraint(buzzardFlockID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(buzzardFlockID, playerConstraint);
	rmAddObjectDefConstraint(buzzardFlockID, avoidStartingUnits);
	rmPlaceObjectDefAtLoc(buzzardFlockID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);

	int randomVultureTreeID=rmCreateObjectDef("random vulture tree");
	rmAddObjectDefItem(randomVultureTreeID, "PropVulturePerching", 1, 3.0);
	rmAddObjectDefItem(randomVultureTreeID, "UnderbrushPampas", rmRandInt(4,6), 3.0);
	rmSetObjectDefMinDistance(randomVultureTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomVultureTreeID, rmXFractionToMeters(0.40));
    rmAddObjectDefConstraint(randomVultureTreeID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(randomVultureTreeID, playerConstraint);
	rmAddObjectDefConstraint(randomVultureTreeID, avoidStartingUnits);
	rmAddObjectDefConstraint(randomVultureTreeID, avoidBuzzards);
	rmAddObjectDefConstraint(randomVultureTreeID, avoidVultures);
	rmAddObjectDefConstraint(randomVultureTreeID, avoidTradeRoute);
	rmAddObjectDefConstraint(randomVultureTreeID, avoidTradeRouteSockets);
	rmPlaceObjectDefAtLoc(randomVultureTreeID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);


	// --------------------------- *** Build Dirt Patches *** ----------------------------------------------
	for (i=0; <10)
	{
		int dirtPatch=rmCreateArea("open dirt patch "+i);
		rmSetAreaWarnFailure(dirtPatch, false);
		rmSetAreaSize(dirtPatch, rmAreaTilesToFraction(20), rmAreaTilesToFraction(50));  // Was 100, 300
		
		rmAddAreaTerrainLayer(dirtPatch, "california\desert2_cal", 0, 4);
        rmAddAreaTerrainLayer(dirtPatch, "california\desert3_cal", 4, 10);
        rmAddAreaTerrainLayer(dirtPatch, "california\desert4_cal", 10, 100);
		
		rmSetAreaMix(dirtPatch, "kalahari_dirt");
		// rmAddAreaTerrainLayer(dirtPatch, "great_plains\ground2_gp", 0, 1);
		rmAddAreaToClass(dirtPatch, rmClassID("classPatch"));
		//rmSetAreaBaseHeight(dirtPatch, 4.0);
		rmSetAreaMinBlobs(dirtPatch, 1);
		rmSetAreaMaxBlobs(dirtPatch, 5);
		rmSetAreaMinBlobDistance(dirtPatch, 16.0);
		rmSetAreaMaxBlobDistance(dirtPatch, 40.0);
		rmSetAreaCoherence(dirtPatch, 0.0);
		rmSetAreaSmoothDistance(dirtPatch, 10);
		rmAddAreaConstraint(dirtPatch, shortAvoidImpassableLand);
		rmAddAreaConstraint(dirtPatch, patchConstraint);
		rmBuildArea(dirtPatch); 
	}


		// Text
	rmSetStatusText("",1.0);
	}
}  
