//==============================================================================
// Rainforest
// by Felix Hermansson, Tsunami Studios (hoodncloak@hotmail.com)
// 3 December 2006
//
// Random Map Script for Age of Empires III: The War Chiefs
//==============================================================================
// History:
// 31-12-05: Original release
// 01-01-06: Added missing herd definitions for huntables
// 11-11-06: Updated for TWC (Caribs replaced by Zapotec)
// 03-12-06: Huari strongholds added
//==============================================================================


//==============================================================================
// includes
//==============================================================================

// include mercenaries
include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//Balance Start

/*
An attempt to fix only the biggest flaws in AOE 3 Vanilla Balance
Using only Scenario Triggers inside the Random Map Scripts for maximum compatibility
Draws some Ideas from the Community ESOC for TAD
and took some changes from the Asian Dynasties
Original Idea by Rikikipu: https://eso-community.net/viewtopic.php?t=6550
This Version fixes some remaining issues with Cards and Tech not taking changes into consideration
and adds some additional Balance Changes

Changes:
1. Halb -10 Food and Gold Cost, Ruyters -5 food, -5 gold 
2. TP -50 Wood Cost(from the Asian Dynasties)
3. Cuirassier -25 Base HP and -5 Gold and -5 Food Cost
4. Oprichnik -25 Base HP and +30 Food Cost, Strelet -5s train time
5. Indian Rajputs -20 wood, Mahouts -50 food and -50 wood, Gurkha -10 gold, +20 HP, Urumi Enabled
6. Monitor Cost decreased by 200 Gold
7. Ports start the game with +50 Wood
8. Tomahawks -25 food, Kanya Horsemen -25 wood, Mantlets -25 wood
9. Ashigarus +10 gold, +5s train time, -1 speed, Yabusames -20 gold, Samurai -10 Food and Gold, +10 HP, -1s train time
10. Dog Soldiers -40s train time, Skull Knights -30s train time
11. Iroquois Travois -15s train time, Medicine Men -15s train time, Warrior Priests -10s train time
12. Heavy Cannons, Great Bombards, Rockets +100 HP, Gatling Guns +50 HP
13. Outposts, Warhuts, Nobles Huts, Blockhosues +7 Build limit, Castles +5 Build limit

*/

void balanceVanilla(void)
{
for(i=1; <cNumberPlayers)
{	
	rmCreateTrigger("OverallBalance"+i);
    rmSwitchToTrigger(rmTriggerID("OverallBalance"+i));
	rmAddTriggerCondition("Timer");
    rmSetTriggerPriority(3);
    rmSetTriggerActive(true);
    rmSetTriggerRunImmediately(true);
    rmSetTriggerLoop(false);   
	rmSetTriggerConditionParamInt("Param1", 3);	
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "Factory");
    rmSetTriggerEffectParamInt("PlayerID", i);
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "ypBankAsian");
    rmSetTriggerEffectParamInt("PlayerID", i);
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "ypGroveBuilding");
    rmSetTriggerEffectParamInt("PlayerID", i);
	
    rmAddTriggerEffect("Unforbid and Enable Unit");
    rmSetTriggerEffectParam("ProtoUnit", "CWallGate");
    rmSetTriggerEffectParamInt("PlayerID", i);
		
    rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "TradingPost");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 16);
    rmSetTriggerEffectParamInt("Delta", -100);
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Monitor");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 15);
    rmSetTriggerEffectParamInt("Delta", -200);	
		
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Cannon");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", 0);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "GreatBombard");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", 0);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Rocket");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", 0);	
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Cannon");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "GreatBombard");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "Rocket");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpGatlingGun");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 50);	
	
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "ypConsulateCannon");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	

	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "ypConsulateGreatBombard");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
    rmSetTriggerEffectParamInt("Delta", 100);	
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "TownCenter");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 5);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "Outpost");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "ypCastle");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 5);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "WarHut");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "NoblesHut");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "Blockhouse");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
	rmSetTriggerEffectParamInt("Delta", 7);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "CoveredWagon");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
	rmSetTriggerEffectParamInt("Delta", 100);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "FortWagon");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
	rmSetTriggerEffectParamInt("Delta", 100);
	
	rmAddTriggerEffect("Modify Protounit");
	rmSetTriggerEffectParam("ProtoUnit", "FactoryWagon");
	rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 0);
	rmSetTriggerEffectParamInt("Delta", 100);

	if ( rmGetPlayerCiv(i) == 3	){
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Cuirassier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Cuirassier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Cuirassier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
	}
	
	if ( rmGetPlayerCiv(i) == 21	){
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -150);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRajput");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -20);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypNatMercGurkha");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypNatMercGurkha");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypSepoy");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", -0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMercFlailiphant");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 1);
		rmSetTriggerEffectParamInt("Delta", 1);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRajput");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypMahout");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -5);
	}
	
	if ( rmGetPlayerCiv(i) == 3
	|| rmGetPlayerCiv(i) == 4
	|| rmGetPlayerCiv(i) == 5
	|| rmGetPlayerCiv(i) == 1
	){
	
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Ruyter");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -5);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Ruyter");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -5);
	}
	
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("Portuguese")){
      rmCreateTrigger("Wood babe"+i);
      rmSwitchToTrigger(rmTriggerID("Wood babe"+i));
      rmSetTriggerPriority(3); 
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);
      rmAddTriggerCondition("Always");
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmSetTriggerEffectParam("ResName", "Wood", false);
      rmSetTriggerEffectParam("Amount", "50", false);
    }	

	if ( rmGetPlayerCiv(i) == rmGetCivID("XPSioux")){
		//Uhlan 35s +5 +4
		//WarWagon 60 +9 +6
	
	rmCreateTrigger("DogTrainTime"+i);
		rmSwitchToTrigger(rmTriggerID("DogTrainTime"+i));
		rmSetTriggerPriority(3);
		rmSetTriggerActive(true);
		rmSetTriggerRunImmediately(false);
		rmSetTriggerLoop(false); 
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpDogSoldier");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -40);
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpMedicineMan");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -15);
	}
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("XPAztec")){
		//Uhlan 35s +5 +4
		//WarWagon 60 +9 +6
	
	rmCreateTrigger("SkullTrainTime"+i);
		rmSwitchToTrigger(rmTriggerID("SkullTrainTime"+i));
		rmSetTriggerPriority(3);
		rmSetTriggerActive(true);
		rmSetTriggerRunImmediately(false);
		rmSetTriggerLoop(false); 
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpSkullKnight");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -25);
	rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "xpMedicineManAztec");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 3);
    rmSetTriggerEffectParamInt("Delta", -10);
	}
	
	if ( rmGetPlayerCiv(i) == 6	){
	
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Halberdier");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -8);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Oprichnik");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 30);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Oprichnik");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Strelet");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -5);
	}
	
	if ( rmGetPlayerCiv(i) == 19	){
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypAshigaru");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypYabusame");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -20);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 15);
		rmSetTriggerEffectParamInt("Delta", -10);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypKensei");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -1);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypAshigaru");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", 1);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypShrineJapanese");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 10);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypAshigaru");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 1);
		rmSetTriggerEffectParamInt("Delta", -1);
	}
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("XPIroquois")){
		//Uhlan 35s +5 +4
		//WarWagon 60 +9 +6
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpTomahawk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", 0);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpMantlet");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 16);
		rmSetTriggerEffectParamInt("Delta", -25);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpBuilder");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -15);
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpMedicineMan");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 3);
		rmSetTriggerEffectParamInt("Delta", -15);
	}

	if ( rmGetPlayerCiv(i) == rmGetCivID("Dutch")){
		//Settler +25
		//Dutch +50%
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "Settler");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 10);
		rmSetTriggerEffectParamInt("Delta", 15);
	}
	
	if ( rmGetPlayerCiv(i) == rmGetCivID("XPSioux")){
		//Axe Rider -40 Food
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "xpAxeRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 17);
		rmSetTriggerEffectParamInt("Delta", -40);
	}

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -6);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -6);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "SaloonPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawPistol");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRider");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantOutlawRifleman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);

		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -3);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantSmuggler");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -3);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -5);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -4);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 6);
		rmSetTriggerEffectParamInt("Delta", -2);
		

		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantSmuggler");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypRepentantWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypDacoit");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouPirate");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWaywardRonin");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouBlindMonk");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypThuggee");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
		
		rmAddTriggerEffect("Modify Protounit");
		rmSetTriggerEffectParam("ProtoUnit", "ypWokouWanderingHorseman");
		rmSetTriggerEffectParamInt("PlayerID", i);
		rmSetTriggerEffectParamInt("Field", 0);
		rmSetTriggerEffectParamInt("Delta", 100);
	
}
}
//Balance Ende
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx 


//==============================================================================
// function main 
// generates map
//==============================================================================

void main(void)
{
   // Map generation status bar
   rmSetStatusText("",0.01);

   // Define map size
   int playerTiles = 24000;
   if (cNumberNonGaiaPlayers >4)
   {
      playerTiles = 20000;
   }
   int size = 2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmSetMapSize(size, size);  

   // Set lighting
   rmSetLightingSet("caribbean");

   // Add wind and rain
   rmSetWindMagnitude(2.0);
   rmSetGlobalRain(0.9);

   // Pick default terrain
   rmSetSeaLevel(0.0);
   rmSetMapElevationParameters(cElevTurbulence, 0.09, 6, 0.2, 6.0);
   rmEnableLocalWater(false);
   rmSetBaseTerrainMix("amazon grass");   
   rmSetMapType("Deccan");
   rmSetMapType("Borneo");
   rmSetMapType("tropical");
   rmSetMapType("CentralAfrica");
   rmSetMapType("land");
   rmSetWorldCircleConstraint(true);

   // Initialize map
   rmTerrainInitialize("amazon\ground2_am",6.0);

   // Create one land area to cover the whole map
   int landAreaID = rmCreateArea("land area");
   rmSetAreaSize(landAreaID, 1.0, 1.0);
   rmSetAreaWarnFailure(landAreaID, false);
   rmSetAreaMix(landAreaID, "amazon grass");
   rmSetAreaElevationType(landAreaID, cElevTurbulence);
   rmSetAreaElevationVariation(landAreaID, 2.0);
   rmSetAreaBaseHeight(landAreaID, 2.0);
   rmSetAreaElevationMinFrequency(landAreaID, 0.09);
   rmSetAreaElevationOctaves(landAreaID, 3);
   rmSetAreaElevationPersistence(landAreaID, 0.2);      
   rmSetAreaCoherence(landAreaID, 1.0);
   rmSetAreaLocation(landAreaID, 0.5, 0.5);
   rmSetAreaEdgeFilling(landAreaID, 5);
   rmSetAreaObeyWorldCircleConstraint(landAreaID, false);
   rmBuildArea(landAreaID);

   // Choose mercs
   chooseMercs();

   // Map generation status bar
   rmSetStatusText("",0.10);


   // Define constraints to have objects and areas avoid each other

   // Define classes
   int classPlayer = rmDefineClass("player");
   rmDefineClass("classCliff");
   rmDefineClass("classLake");
   rmDefineClass("classPatch");
   rmDefineClass("starting settlement");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("importantItem");
   rmDefineClass("natives");
   rmDefineClass("huari");
   rmDefineClass("nuggets");
   rmDefineClass("center");

   // Corner constraint
   rmSetWorldCircleConstraint(true);
   
   // Map edge constraints
   int playerEdgeConstraint = rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
   int longPlayerEdgeConstraint = rmCreateBoxConstraint("long avoid edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
   
   // Center constraints
   int centerConstraint = rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), rmXFractionToMeters(0.10));
   int centerConstraintFar = rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), rmXFractionToMeters(0.23));
   int centerConstraintExtreme = rmCreateClassDistanceConstraint("stay away from center extremely far", rmClassID("center"), rmXFractionToMeters(0.50));

   // General circle constraint
   int circleConstraint = rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

   // Cardinal direction constraints
   int Northward = rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
   int Southward = rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
   int Eastward = rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
   int Westward = rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

   // Player constraints
   int extremePlayerConstraint = rmCreateClassDistanceConstraint("extreme distance player constraint", classPlayer, 100.0);
   int longPlayerConstraint = rmCreateClassDistanceConstraint("long distance player constraint", classPlayer, 70.0);
   int playerConstraint = rmCreateClassDistanceConstraint("standard distance player constraint", classPlayer, 45.0);
   int shortPlayerConstraint = rmCreateClassDistanceConstraint("short distance player constraint", classPlayer, 20.0);

   // Nature constraints (forests, mines & starting resources)
   int forestObjConstraint = rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
   int forestConstraint = rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 40.0);
   int avoidCoin = rmCreateTypeDistanceConstraint("avoid coin", "Mine", 40.0);
   int shortAvoidCoin = rmCreateTypeDistanceConstraint("short avoid coin", "gold", 10.0);
   int avoidResource = rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
   int avoidStartResource = rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 10.0);

   // Impassable land constraints
   int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
   int shortAvoidImpassableLand = rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
   int longAvoidImpassableLand = rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);

   // Cliff constraints
   int avoidCliffs = rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 40.0);
   int avoidCliffsShort = rmCreateClassDistanceConstraint("short avoid cliff", rmClassID("classCliff"), 10.0);

   // Lake constraints
   int avoidLakes = rmCreateClassDistanceConstraint("lake vs. lake", rmClassID("classLake"), 150.0);
   int avoidLakesShort = rmCreateClassDistanceConstraint("short avoid lake", rmClassID("classLake"), 10.0);

   // Unit constraints
   int avoidStartingUnits = rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 45.0);
   int shortAvoidStartingUnits = rmCreateClassDistanceConstraint("objects avoid starting units short", rmClassID("startingUnit"), 10.0);
   int avoidImportantItem = rmCreateClassDistanceConstraint("general items avoid each other", rmClassID("importantItem"), 10.0);
   int avoidNatives = rmCreateClassDistanceConstraint("objects avoid natives", rmClassID("natives"), 30.0);
   int avoidNativesLong = rmCreateClassDistanceConstraint("objects avoid natives long", rmClassID("natives"), 70.0);
   int avoidNativesExtreme = rmCreateClassDistanceConstraint("objects avoid natives extreme", rmClassID("natives"), 100.0);
   int avoidHuari = rmCreateClassDistanceConstraint("objects avoid huari", rmClassID("huari"), 30.0);
   int avoidHuariLong = rmCreateClassDistanceConstraint("objects avoid huari long", rmClassID("huari"), 70.0);
   int avoidHuariExtreme = rmCreateClassDistanceConstraint("objects avoid huari extreme", rmClassID("huari"), 100.0);
   int avoidNuggets = rmCreateClassDistanceConstraint("objects avoid nuggets", rmClassID("nuggets"), 60.0);
   int avoidNuggetsHuari = rmCreateClassDistanceConstraint("huari avoid nuggets", rmClassID("nuggets"), 30.0);
   int shortNuggetConstraint = rmCreateTypeDistanceConstraint("avoid nugget objects", "AbstractNugget", 7.0);
   int tapirConstraint = rmCreateTypeDistanceConstraint("tapirs avoid tapirs", "tapir", 40.0);
   int capybaraConstraint = rmCreateTypeDistanceConstraint("capybaras avoid capybaras", "capybara", 40.0);
   int elephantConstraint = rmCreateTypeDistanceConstraint("capybaras avoid capybaras", "ypWildElephant", 40.0);

   // General constraint (used mostly for decoration objects)
   int avoidAll = rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
   int avoidAll2 = rmCreateTypeDistanceConstraint("avoid all", "all", 2.0);
   int avoidImpassableLand2 = rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);

   // Map generation status bar
   rmSetStatusText("",0.20);


   // Place players

   // Place players in a rough circle on the outskirts of the map
   rmSetTeamSpacingModifier(0.7);
   rmPlacePlayersCircular(0.3, 0.45, rmDegreesToRadians(360/(cNumberNonGaiaPlayers*3)));

   // Create player areas
   float playerFraction = rmAreaTilesToFraction(100);
   for(i=1; <cNumberPlayers)
   {
      int id = rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmAddAreaConstraint(id, longAvoidImpassableLand);
      rmSetAreaLocPlayer(id, i);
      rmSetAreaWarnFailure(id, false);
   }

   // Build all player areas
   rmBuildAllAreas();

   // Map generation status bar
   rmSetStatusText("",0.30);


   // Define and place starting units and resources

   // Define TC or covered wagon
   int startingTCID =  rmCreateObjectDef("startingTC");
   if (rmGetNomadStart())
   {
      rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 5.0);   
   }
   else
   {
      rmAddObjectDefItem(startingTCID, "townCenter", 1, 5.0);
   }
   rmAddObjectDefConstraint(startingTCID, avoidImpassableLand);
   rmAddObjectDefToClass(startingTCID, rmClassID("player"));

   // Define starting units (explorer, war chief, etc.)
   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 10.0);
   rmSetObjectDefMaxDistance(startingUnits, 12.0);
   rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
   
   int startingUnits2 = rmCreateObjectDef("extra units");
   rmAddObjectDefItem(startingUnits2, "CoveredWagon", 3, 10.0);
   rmAddObjectDefItem(startingUnits2, "ypBankWagon", 1, 10.0);
   rmAddObjectDefItem(startingUnits2, "YPGroveWagon", 1, 10.0);
   rmSetObjectDefMinDistance(startingUnits2, 8.0);
   rmSetObjectDefMaxDistance(startingUnits2, 15.0);
   rmAddObjectDefConstraint(startingUnits2, avoidAll2);
   rmAddObjectDefConstraint(startingUnits2, avoidImpassableLand2);
   rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));

   // Define starting mine close
   int startSilver1ID = rmCreateObjectDef("player silver close");
   rmAddObjectDefItem(startSilver1ID, "mine", 1, 5.0);
   rmSetObjectDefMinDistance(startSilver1ID, 12.0);
   rmSetObjectDefMaxDistance(startSilver1ID, 20.0);
   rmAddObjectDefConstraint(startSilver1ID, avoidStartResource);
   rmAddObjectDefConstraint(startSilver1ID, avoidImpassableLand);

   // Define starting mine medium
   int startSilver2ID = rmCreateObjectDef("player silver medium");
   rmAddObjectDefItem(startSilver2ID, "mine", 1, 5.0);
   rmSetObjectDefMinDistance(startSilver2ID, 45.0);
   rmSetObjectDefMaxDistance(startSilver2ID, 50.0);
   rmAddObjectDefConstraint(startSilver2ID, playerConstraint);
   rmAddObjectDefConstraint(startSilver2ID, avoidImpassableLand);

   // Define starting mine far
   int startSilver3ID = rmCreateObjectDef("player silver far");
   rmAddObjectDefItem(startSilver3ID, "mine", 1, 5.0);
   rmSetObjectDefMinDistance(startSilver3ID, 80.0);
   rmSetObjectDefMaxDistance(startSilver3ID, 100.0);
   rmAddObjectDefConstraint(startSilver3ID, longPlayerConstraint);
   rmAddObjectDefConstraint(startSilver3ID, avoidImpassableLand);

   // Define starting turkeys
   int startTurkeyID = rmCreateObjectDef("starting turkeys");
   rmAddObjectDefItem(startTurkeyID, "ypNilgai", rmRandInt(6,8), 8.0);
   rmSetObjectDefMinDistance(startTurkeyID, 10);
   rmSetObjectDefMaxDistance(startTurkeyID, 16);
   rmAddObjectDefConstraint(startTurkeyID, avoidStartResource);
   rmAddObjectDefConstraint(startTurkeyID, shortAvoidImpassableLand);
   rmSetObjectDefCreateHerd(startTurkeyID, true);

   // Define starting capybaras
   int startCapybaraID = rmCreateObjectDef("starting capybaras");
   rmAddObjectDefItem(startCapybaraID, "ypWildElephant", rmRandInt(2,5), 8.0);
   rmSetObjectDefMinDistance(startCapybaraID, 24);
   rmSetObjectDefMaxDistance(startCapybaraID, 36);
   rmAddObjectDefConstraint(startCapybaraID, avoidStartResource);
   rmAddObjectDefConstraint(startCapybaraID, shortAvoidImpassableLand);
   rmSetObjectDefCreateHerd(startCapybaraID, true);

   // Define starting trees
   int startAreaTreeID = rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(startAreaTreeID, "TreeAmazon", rmRandInt(6,8), 8.0);
   rmSetObjectDefMinDistance(startAreaTreeID, 8);
   rmSetObjectDefMaxDistance(startAreaTreeID, 16);
   rmAddObjectDefConstraint(startAreaTreeID, avoidStartResource);
   rmAddObjectDefConstraint(startAreaTreeID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(startAreaTreeID, shortAvoidStartingUnits);

   // Place starting units and resources for all payers 
   for(i=1; <cNumberPlayers)
   {
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startSilver1ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startSilver2ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startSilver3ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits2, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startTurkeyID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startCapybaraID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

   // Map generation status bar
   rmSetStatusText("",0.40);


   // Define and place natives

   // Choose natives per village (Tupi or Zapotec)
   int subCiv0 = -1;
   int subCiv1 = -1;
   int subCiv2 = -1;
   int subCiv3 = -1;
   int subCiv4 = -1;
   int subCiv5 = -1;
   float nativeChooser = 0;
   if (rmAllocateSubCivs(6) == true)
   {
      // First village
      nativeChooser = rmRandFloat(0,1);
      if (nativeChooser <= 0.5)
      {
         subCiv0 = rmGetCivID("Caribs");
         if (subCiv0 >= 0)
         {
            rmSetSubCiv(0, "Caribs", true);
         }
      }
      else
      {
         subCiv0 = rmGetCivID("Caribs");
         if (subCiv0 >= 0)
         {
            rmSetSubCiv(0, "Caribs", true);
         }
      }
      // Second village
      nativeChooser = rmRandFloat(0,1);
      if (nativeChooser <= 0.5)
      {
         subCiv1 = rmGetCivID("Caribs");
         if (subCiv1 >= 0)
         {
            rmSetSubCiv(1, "Caribs", true);
         }
      }
      else
      {
         subCiv1 = rmGetCivID("Caribs");
         if (subCiv1 >= 0)
         {
            rmSetSubCiv(1, "Caribs", true);
         }
      }
      // Third village
      nativeChooser = rmRandFloat(0,1);
      if (nativeChooser <= 0.5)
      {
         subCiv2 = rmGetCivID("Zapotec");
         if (subCiv2 >= 0)
         {
            rmSetSubCiv(2, "Zapotec", true);
         }
      }
      else
      {
         subCiv2 = rmGetCivID("Zapotec");
         if (subCiv2 >= 0)
         {
            rmSetSubCiv(2, "Zapotec", true);
         }
      }
      // Fourth village
      nativeChooser = rmRandFloat(0,1);
      if (nativeChooser <= 0.5)
      {
         subCiv3 = rmGetCivID("Caribs");
         if (subCiv3 >= 0)
         {
            rmSetSubCiv(3, "Caribs", true);
         }
      }
      else
      {
         subCiv3 = rmGetCivID("Caribs");
         if (subCiv3 >= 0)
         {
            rmSetSubCiv(3, "Caribs", true);
         }
      }
      // Fifth village
      nativeChooser = rmRandFloat(0,1);
      if (nativeChooser <= 0.5)
      {
         subCiv4 = rmGetCivID("Zapotec");
         if (subCiv4 >= 0)
         {
            rmSetSubCiv(4, "Zapotec", true);
         }
      }
      else
      {
         subCiv4 = rmGetCivID("Zapotec");
         if (subCiv4 >= 0)
         {
            rmSetSubCiv(4, "Zapotec", true);
         }
      }
      // Sixth village
      nativeChooser = rmRandFloat(0,1);
      if (nativeChooser <= 0.5)
      {
         subCiv5 = rmGetCivID("Caribs");
         if (subCiv5 >= 0)
         {
            rmSetSubCiv(5, "Caribs", true);
         }
      }
      else
      {
         subCiv5 = rmGetCivID("Caribs");
         if (subCiv5 >= 0)
         {
            rmSetSubCiv(5, "Caribs", true);
         }
      }
   }

   // Define and place native villages
   int nativeVillage1ID = -1;
   int nativeVillage2ID = -1;
   int nativeVillage3ID = -1;
   int nativeVillage4ID = -1;
   int nativeVillage5ID = -1;
   int nativeVillage6ID = -1;
   if (subCiv0 == rmGetCivID("Caribs"))
   {
      // Tupi village 1
      int tupiVillage1Type = rmRandInt(1,5);
      nativeVillage1ID = rmCreateGrouping("native village 1", "native carib village 0"+tupiVillage1Type);
      rmSetGroupingMinDistance(nativeVillage1ID, 0.0);
      rmSetGroupingMaxDistance(nativeVillage1ID, rmXFractionToMeters(0.35));
      rmAddGroupingConstraint(nativeVillage1ID, extremePlayerConstraint);
      rmAddGroupingConstraint(nativeVillage1ID, avoidNativesExtreme);
      rmAddGroupingToClass(nativeVillage1ID, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillage1ID, rmClassID("importantItem"));
      rmPlaceGroupingAtLoc(nativeVillage1ID, 0, 0.5, 0.5);
   }
   else
   {
      // Zapotec village 1
      int zapotecVillage1Type = rmRandInt(1,5);
      nativeVillage1ID = rmCreateGrouping("native village 1", "native zapotec village "+zapotecVillage1Type);
      rmSetGroupingMinDistance(nativeVillage1ID, 0.0);
      rmSetGroupingMaxDistance(nativeVillage1ID, rmXFractionToMeters(0.35));
      rmAddGroupingConstraint(nativeVillage1ID, extremePlayerConstraint);
      rmAddGroupingConstraint(nativeVillage1ID, avoidNativesExtreme);
      rmAddGroupingToClass(nativeVillage1ID, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillage1ID, rmClassID("importantItem"));
      rmPlaceGroupingAtLoc(nativeVillage1ID, 0, 0.5, 0.5);
   }
   if (subCiv1 == rmGetCivID("Caribs"))
   {
      // Tupi village 2
      int tupiVillage2Type = rmRandInt(1,5);
      nativeVillage2ID = rmCreateGrouping("native village 2", "native carib village 0"+tupiVillage2Type);
      rmSetGroupingMinDistance(nativeVillage2ID, 0.0);
      rmSetGroupingMaxDistance(nativeVillage2ID, rmXFractionToMeters(0.35));
      rmAddGroupingConstraint(nativeVillage2ID, extremePlayerConstraint);
      rmAddGroupingConstraint(nativeVillage2ID, avoidNativesExtreme);
      rmAddGroupingToClass(nativeVillage2ID, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillage2ID, rmClassID("importantItem"));
      rmPlaceGroupingAtLoc(nativeVillage2ID, 0, 0.5, 0.5);
   }
   else
   {
      // Zapotec village 2
      int zapotecVillage2Type = rmRandInt(1,5);
      nativeVillage2ID = rmCreateGrouping("native village 2", "native zapotec village "+zapotecVillage2Type);
      rmSetGroupingMinDistance(nativeVillage2ID, 0.0);
      rmSetGroupingMaxDistance(nativeVillage2ID, rmXFractionToMeters(0.35));
      rmAddGroupingConstraint(nativeVillage2ID, extremePlayerConstraint);
      rmAddGroupingConstraint(nativeVillage2ID, avoidNativesExtreme);
      rmAddGroupingToClass(nativeVillage2ID, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillage2ID, rmClassID("importantItem"));
      rmPlaceGroupingAtLoc(nativeVillage2ID, 0, 0.5, 0.5);
   }
   if (subCiv2 == rmGetCivID("Zapotec"))
   {
      // Tupi village 3
      int tupiVillage3Type = rmRandInt(1,5);
      nativeVillage3ID = rmCreateGrouping("native village 3", "native zapotec village "+tupiVillage3Type);
      rmSetGroupingMinDistance(nativeVillage3ID, 0.0);
      rmSetGroupingMaxDistance(nativeVillage3ID, rmXFractionToMeters(0.35));
      rmAddGroupingConstraint(nativeVillage3ID, extremePlayerConstraint);
      rmAddGroupingConstraint(nativeVillage3ID, avoidNativesExtreme);
      rmAddGroupingToClass(nativeVillage3ID, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillage3ID, rmClassID("importantItem"));
      rmPlaceGroupingAtLoc(nativeVillage3ID, 0, 0.5, 0.5);
   }
   else
   {
      // Zapotec village 3
      int zapotecVillage3Type = rmRandInt(1,5);
      nativeVillage3ID = rmCreateGrouping("native village 3", "native zapotec village "+zapotecVillage3Type);
      rmSetGroupingMinDistance(nativeVillage3ID, 0.0);
      rmSetGroupingMaxDistance(nativeVillage3ID, rmXFractionToMeters(0.35));
      rmAddGroupingConstraint(nativeVillage3ID, extremePlayerConstraint);
      rmAddGroupingConstraint(nativeVillage3ID, avoidNativesExtreme);
      rmAddGroupingToClass(nativeVillage3ID, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillage3ID, rmClassID("importantItem"));
      rmPlaceGroupingAtLoc(nativeVillage3ID, 0, 0.5, 0.5);
   }
   if (subCiv3 == rmGetCivID("Caribs"))
   {
      // Tupi village 4
      int tupiVillage4Type = rmRandInt(1,5);
      nativeVillage4ID = rmCreateGrouping("native village 4", "native carib village 0"+tupiVillage4Type);
      rmSetGroupingMinDistance(nativeVillage4ID, 0.0);
      rmSetGroupingMaxDistance(nativeVillage4ID, rmXFractionToMeters(0.35));
      rmAddGroupingConstraint(nativeVillage4ID, extremePlayerConstraint);
      rmAddGroupingConstraint(nativeVillage4ID, avoidNativesExtreme);
      rmAddGroupingToClass(nativeVillage4ID, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillage4ID, rmClassID("importantItem"));
      rmPlaceGroupingAtLoc(nativeVillage4ID, 0, 0.5, 0.5);
   }
   else
   {
      // Zapotec village 4
      int zapotecVillage4Type = rmRandInt(1,5);
      nativeVillage4ID = rmCreateGrouping("native village 4", "native zapotec village "+zapotecVillage4Type);
      rmSetGroupingMinDistance(nativeVillage4ID, 0.0);
      rmSetGroupingMaxDistance(nativeVillage4ID, rmXFractionToMeters(0.35));
      rmAddGroupingConstraint(nativeVillage4ID, extremePlayerConstraint);
      rmAddGroupingConstraint(nativeVillage4ID, avoidNativesExtreme);
      rmAddGroupingToClass(nativeVillage4ID, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillage4ID, rmClassID("importantItem"));
      rmPlaceGroupingAtLoc(nativeVillage4ID, 0, 0.5, 0.5);
   }
   if (cNumberNonGaiaPlayers > 3)
   {
      if (subCiv4 == rmGetCivID("Zapotec"))
      {
         // Tupi village 5
         int tupiVillage5Type = rmRandInt(1,5);
         nativeVillage5ID = rmCreateGrouping("native village 5", "native zapotec village "+tupiVillage5Type);
         rmSetGroupingMinDistance(nativeVillage5ID, 0.0);
         rmSetGroupingMaxDistance(nativeVillage5ID, rmXFractionToMeters(0.35));
         rmAddGroupingConstraint(nativeVillage5ID, extremePlayerConstraint);
         rmAddGroupingConstraint(nativeVillage5ID, avoidNativesExtreme);
         rmAddGroupingToClass(nativeVillage5ID, rmClassID("natives"));
         rmAddGroupingToClass(nativeVillage5ID, rmClassID("importantItem"));
         rmPlaceGroupingAtLoc(nativeVillage5ID, 0, 0.5, 0.5);
      }
      else
      {
         // Zapotec village 5
         int zapotecVillage5Type = rmRandInt(1,5);
         nativeVillage5ID = rmCreateGrouping("native village 5", "native zapotec village "+zapotecVillage5Type);
         rmSetGroupingMinDistance(nativeVillage5ID, 0.0);
         rmSetGroupingMaxDistance(nativeVillage5ID, rmXFractionToMeters(0.35));
         rmAddGroupingConstraint(nativeVillage5ID, extremePlayerConstraint);
         rmAddGroupingConstraint(nativeVillage5ID, avoidNativesExtreme);
         rmAddGroupingToClass(nativeVillage5ID, rmClassID("natives"));
         rmAddGroupingToClass(nativeVillage5ID, rmClassID("importantItem"));
         rmPlaceGroupingAtLoc(nativeVillage5ID, 0, 0.5, 0.5);
     }
     if (subCiv5 == rmGetCivID("Caribs"))
     {
         // Tupi village 6
         int tupiVillage6Type = rmRandInt(1,5);
         nativeVillage6ID = rmCreateGrouping("native village 6", "native carib village 0"+tupiVillage6Type);
         rmSetGroupingMinDistance(nativeVillage6ID, 0.0);
         rmSetGroupingMaxDistance(nativeVillage6ID, rmXFractionToMeters(0.35));
         rmAddGroupingConstraint(nativeVillage6ID, extremePlayerConstraint);
         rmAddGroupingConstraint(nativeVillage6ID, avoidNativesExtreme);
         rmAddGroupingToClass(nativeVillage6ID, rmClassID("natives"));
         rmAddGroupingToClass(nativeVillage6ID, rmClassID("importantItem"));
         rmPlaceGroupingAtLoc(nativeVillage6ID, 0, 0.5, 0.5);
     }
     else
     {
         // Zapotec village 6
         int zapotecVillage6Type = rmRandInt(1,5);
         nativeVillage6ID = rmCreateGrouping("native village 6", "native zapotec village "+zapotecVillage6Type);
         rmSetGroupingMinDistance(nativeVillage6ID, 0.0);
         rmSetGroupingMaxDistance(nativeVillage6ID, rmXFractionToMeters(0.35));
         rmAddGroupingConstraint(nativeVillage6ID, extremePlayerConstraint);
         rmAddGroupingConstraint(nativeVillage6ID, avoidNativesExtreme);
         rmAddGroupingToClass(nativeVillage6ID, rmClassID("natives"));
         rmAddGroupingToClass(nativeVillage6ID, rmClassID("importantItem"));
         rmPlaceGroupingAtLoc(nativeVillage6ID, 0, 0.5, 0.5);
      }
   }

   // Map generation status bar
   rmSetStatusText("",0.50);


   // Place cliffs and lakes

   // Define and place cliffs
   int numCliffs = cNumberNonGaiaPlayers * 4;
   for (i=0; <numCliffs)
   {
      int cliffID = rmCreateArea("cliff"+i);
      rmSetAreaSize(cliffID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(700));
      rmSetAreaWarnFailure(cliffID, false);
      rmSetAreaCliffType(cliffID, "Amazon");
      rmSetAreaCliffEdge(cliffID, 2, 0.3, 0.1, 1.0, 0);
      rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
      rmSetAreaCliffHeight(cliffID, 7, 2.0, 0.5);
      rmSetAreaHeightBlend(cliffID, 1);
      rmSetAreaObeyWorldCircleConstraint(cliffID, false);
      rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
      rmAddAreaConstraint(cliffID, avoidImportantItem);
      rmAddAreaConstraint(cliffID, avoidImpassableLand);
      rmAddAreaConstraint(cliffID, avoidCliffs);
      rmAddAreaConstraint(cliffID, playerConstraint);
      rmAddAreaConstraint(cliffID, avoidStartingUnits);
      rmSetAreaMinBlobs(cliffID, 2);
      rmSetAreaMaxBlobs(cliffID, 3);
      rmSetAreaMinBlobDistance(cliffID, 5.0);
      rmSetAreaMaxBlobDistance(cliffID, 20.0);
      rmSetAreaSmoothDistance(cliffID, 5);
      rmSetAreaCoherence(cliffID, 0.5);
      rmBuildArea(cliffID);
   }

   // Define and place lakes
   int numLakes = rmRandInt(4, (cNumberNonGaiaPlayers + 2)); 
   for (i=0; <numLakes)
   {
      int lakeID = rmCreateArea("lake"+i);
      rmSetAreaSize(lakeID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(600));
      rmSetAreaWarnFailure(lakeID, false);
      rmSetAreaWaterType(lakeID, "bayou");
      rmSetAreaBaseHeight(lakeID, 1.0);
      rmSetAreaObeyWorldCircleConstraint(lakeID, false);
      rmAddAreaToClass(lakeID, rmClassID("classLake"));
      rmAddAreaConstraint(lakeID, avoidImportantItem);
      rmAddAreaConstraint(lakeID, avoidImpassableLand);
      rmAddAreaConstraint(lakeID, avoidCliffs);
      rmAddAreaConstraint(lakeID, avoidLakes);
      rmAddAreaConstraint(lakeID, playerConstraint);
      rmAddAreaConstraint(lakeID, avoidStartingUnits);
      rmSetAreaMinBlobs(lakeID, 2);
      rmSetAreaMaxBlobs(lakeID, 3);
      rmSetAreaMinBlobDistance(lakeID, 5.0);
      rmSetAreaMaxBlobDistance(lakeID, 20.0);
      rmSetAreaSmoothDistance(lakeID, 5);
      rmSetAreaCoherence(lakeID, 0.5);
      rmBuildArea(lakeID);
   }

   // Map generation status bar
   rmSetStatusText("",0.60);


   // Place forests and silver mines

   // Place additional silver mines
   int silverCount = cNumberNonGaiaPlayers*8;
   int silverMineID = rmCreateObjectDef("silver mines");
   rmAddObjectDefItem(silverMineID, "mine", 1, 0.0);
   rmSetObjectDefMinDistance(silverMineID, 0.0);
   rmSetObjectDefMaxDistance(silverMineID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(silverMineID, avoidImpassableLand);
   rmAddObjectDefConstraint(silverMineID, avoidCoin);
   rmAddObjectDefConstraint(silverMineID, longPlayerConstraint);
   rmAddObjectDefConstraint(silverMineID, avoidCliffsShort);
   rmAddObjectDefConstraint(silverMineID, avoidLakesShort);

   rmAddObjectDefConstraint(silverMineID, avoidAll);
   for(i=0; <silverCount)
   { 
      rmPlaceObjectDefAtLoc(silverMineID, 0, 0.5, 0.5);
   }

   // Place forests, lots of forests
   int forestCount = -1;
   int failCount = -1;
   int forestTreeID = 0;
   forestCount = size;
   failCount = 0;
   for (i=0; <forestCount)  // Northern forests
   {   
      int northForest=rmCreateArea("northforest"+i);
      rmSetAreaWarnFailure(northForest, false);
      rmSetAreaSize(northForest, rmAreaTilesToFraction(20), rmAreaTilesToFraction(100));
      rmSetAreaForestType(northForest, "amazon rain forest");
      rmSetAreaForestDensity(northForest, 1.0);
      rmAddAreaToClass(northForest, rmClassID("classForest"));
      rmSetAreaForestClumpiness(northForest, 0.0);
      rmSetAreaForestUnderbrush(northForest, 0.0);
      rmSetAreaBaseHeight(northForest, 2.0);
      rmSetAreaMinBlobs(northForest, 1);
      rmSetAreaMaxBlobs(northForest, 3);
      rmSetAreaMinBlobDistance(northForest, 16.0);
      rmSetAreaMaxBlobDistance(northForest, 30.0);
      rmSetAreaCoherence(northForest, 0.7);
      rmSetAreaSmoothDistance(northForest, 1);
      rmAddAreaConstraint(northForest, avoidImportantItem);
      rmAddAreaConstraint(northForest, avoidLakesShort);
      rmAddAreaConstraint(northForest, shortAvoidCoin);
      rmAddAreaConstraint(northForest, shortPlayerConstraint);
      rmAddAreaConstraint(northForest, Northward);
      if(rmBuildArea(northForest) == false)
      {
         // Stop placement once it fails 5 times in a row 
         failCount++;
         if(failCount == 5)
         {      
		break;
         }
      }
      else
      {
         failCount = 0;
      }
   }
   failCount = 0;
   for (i=0; <forestCount)  // Southern forests
   {   
      int southForest=rmCreateArea("southforest"+i);
      rmSetAreaWarnFailure(southForest, false);
      rmSetAreaSize(southForest, rmAreaTilesToFraction(20), rmAreaTilesToFraction(100));
      rmSetAreaForestType(southForest, "amazon rain forest");
      rmSetAreaForestDensity(southForest, 1.0);
      rmAddAreaToClass(southForest, rmClassID("classForest"));
      rmSetAreaForestClumpiness(southForest, 0.0);
      rmSetAreaForestUnderbrush(southForest, 0.0);
      rmSetAreaBaseHeight(southForest, 2.0);
      rmSetAreaMinBlobs(southForest, 1);
      rmSetAreaMaxBlobs(southForest, 3);
      rmSetAreaMinBlobDistance(southForest, 16.0);
      rmSetAreaMaxBlobDistance(southForest, 30.0);
      rmSetAreaCoherence(southForest, 0.7);
      rmSetAreaSmoothDistance(southForest, 1);
      rmAddAreaConstraint(southForest, avoidImportantItem);
      rmAddAreaConstraint(southForest, avoidLakesShort);
      rmAddAreaConstraint(southForest, shortAvoidCoin);
      rmAddAreaConstraint(southForest, shortPlayerConstraint);
      rmAddAreaConstraint(southForest, Southward);
      if(rmBuildArea(southForest)==false)
      {
         // Stop placement once it fails 5 times in a row 
         failCount++;
         if(failCount == 5)
         {      
		break;
         }
      }
      else
      {
         failCount = 0;
      }
   }

   // Map generation status bar
   rmSetStatusText("",0.70);


   // Place additional animals

   // Place tapirs
   int tapirCount = rmRandInt(3,5);
   int tapirHerdCount = 2*cNumberNonGaiaPlayers + rmRandInt(1,cNumberNonGaiaPlayers);
   int tapirNorthID = rmCreateObjectDef("tapir herd north");
   rmAddObjectDefItem(tapirNorthID, "Capybara", tapirCount, 5.0);
   rmSetObjectDefMinDistance(tapirNorthID, 0.0);
   rmSetObjectDefMaxDistance(tapirNorthID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(tapirNorthID, avoidImpassableLand);
   rmAddObjectDefConstraint(tapirNorthID, shortAvoidCoin);
   rmAddObjectDefConstraint(tapirNorthID, playerConstraint);
   rmAddObjectDefConstraint(tapirNorthID, tapirConstraint);
   rmAddObjectDefConstraint(tapirNorthID, capybaraConstraint);
   rmAddObjectDefConstraint(tapirNorthID, Northward);
   rmSetObjectDefCreateHerd(tapirNorthID, true);
   for(i=0; <tapirHerdCount)
   { 
      rmPlaceObjectDefAtLoc(tapirNorthID, 0, 0.5, 0.5); // northern half of the map
   }
   int tapirSouthID = rmCreateObjectDef("tapir herd south");
   rmAddObjectDefItem(tapirSouthID, "Capybara", tapirCount, 5.0);
   rmSetObjectDefMinDistance(tapirSouthID, 0.0);
   rmSetObjectDefMaxDistance(tapirSouthID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(tapirSouthID, avoidImpassableLand);
   rmAddObjectDefConstraint(tapirSouthID, shortAvoidCoin);
   rmAddObjectDefConstraint(tapirSouthID, playerConstraint);
   rmAddObjectDefConstraint(tapirSouthID, tapirConstraint);
   rmAddObjectDefConstraint(tapirSouthID, capybaraConstraint);
   rmAddObjectDefConstraint(tapirSouthID, Southward);
   rmSetObjectDefCreateHerd(tapirSouthID, true);
   for(i=0; <tapirHerdCount)
   { 
      rmPlaceObjectDefAtLoc(tapirSouthID, 0, 0.5, 0.5); // Southern half of the map
   }

   // Place capybaras
   int capybaraCount = rmRandInt(7,9);
   int capybaraHerdCount = 3*cNumberNonGaiaPlayers + rmRandInt(1,cNumberNonGaiaPlayers);
   int capybaraNorthID = rmCreateObjectDef("capybara herd north");
   rmAddObjectDefItem(capybaraNorthID, "ypWildElephant", capybaraCount, 3.0);
   rmSetObjectDefMinDistance(capybaraNorthID, 0.0);
   rmSetObjectDefMaxDistance(capybaraNorthID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(capybaraNorthID, avoidImpassableLand);
   rmAddObjectDefConstraint(capybaraNorthID, shortAvoidCoin);
   rmAddObjectDefConstraint(capybaraNorthID, playerConstraint);
   rmAddObjectDefConstraint(capybaraNorthID, tapirConstraint);
   rmAddObjectDefConstraint(capybaraNorthID, capybaraConstraint);
   rmAddObjectDefConstraint(capybaraNorthID, elephantConstraint);
   rmAddObjectDefConstraint(capybaraNorthID, Northward);
   rmSetObjectDefCreateHerd(capybaraNorthID, true);
   for(i=0; <capybaraHerdCount)
   { 
      rmPlaceObjectDefAtLoc(capybaraNorthID, 0, 0.5, 0.5); // northern half of the map
   }
   int capybaraSouthID = rmCreateObjectDef("capybara herd south");
   rmAddObjectDefItem(capybaraSouthID, "ypWildElephant", capybaraCount, 3.0);
   rmSetObjectDefMinDistance(capybaraSouthID, 0.0);
   rmSetObjectDefMaxDistance(capybaraSouthID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(capybaraSouthID, avoidImpassableLand);
   rmAddObjectDefConstraint(capybaraSouthID, shortAvoidCoin);
   rmAddObjectDefConstraint(capybaraSouthID, playerConstraint);
   rmAddObjectDefConstraint(capybaraSouthID, tapirConstraint);
   rmAddObjectDefConstraint(capybaraSouthID, capybaraConstraint);
   rmAddObjectDefConstraint(capybaraSouthID, elephantConstraint);
   rmAddObjectDefConstraint(capybaraSouthID, Southward);
   rmSetObjectDefCreateHerd(capybaraSouthID, true);
   for(i=0; <capybaraHerdCount)
   { 
      rmPlaceObjectDefAtLoc(capybaraSouthID, 0, 0.5, 0.5); // Southern half of the map
   }

balanceVanilla();  
  
    // Starter shipment triggers
  for(i = 1; < cNumberPlayers) {
    rmCreateTrigger("XP"+i);
    rmSwitchToTrigger(rmTriggerID("XP"+i));
    rmSetTriggerPriority(3); 
    rmSetTriggerActive(true);
    rmSetTriggerRunImmediately(true);
    rmSetTriggerLoop(false);
      
    rmAddTriggerCondition("Always");
    
    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "XP", false);
    rmSetTriggerEffectParam("Amount", "10000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Trade", false);
    rmSetTriggerEffectParam("Amount", "5000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Food", false);
    rmSetTriggerEffectParam("Amount", "25000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Wood", false);
    rmSetTriggerEffectParam("Amount", "15000", false);

    rmAddTriggerEffect("Grant Resources");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParam("ResName", "Gold", false);
    rmSetTriggerEffectParam("Amount", "15000", false);
  } 
   
   // Map generation status bar
   rmSetStatusText("",0.80);


   // Define and place Nuggets

   // Easy nuggets (3 per player, close to the TC)
   int nugget1= rmCreateObjectDef("nugget easy"); 
   rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(1, 1);
   rmAddObjectDefToClass(nugget1, rmClassID("nuggets"));
   rmAddObjectDefConstraint(nugget1, shortPlayerConstraint);
   rmAddObjectDefConstraint(nugget1, avoidImpassableLand);
   rmAddObjectDefConstraint(nugget1, avoidNuggets);
   rmAddObjectDefConstraint(nugget1, avoidAll);
   rmAddObjectDefConstraint(nugget1, circleConstraint);
   rmSetObjectDefMinDistance(nugget1, 30.0);
   rmSetObjectDefMaxDistance(nugget1, 50.0);
   rmPlaceObjectDefPerPlayer(nugget1, false, 3);

   // Medium nuggets (4 per player, further from the TC)
   int nugget2= rmCreateObjectDef("nugget medium"); 
   rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 2);
   rmAddObjectDefToClass(nugget2, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(nugget2, 0.0);
   rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(nugget2, shortPlayerConstraint);
   rmAddObjectDefConstraint(nugget2, avoidImpassableLand);
   rmAddObjectDefConstraint(nugget2, avoidNuggets);
   rmAddObjectDefConstraint(nugget2, circleConstraint);
   rmAddObjectDefConstraint(nugget2, avoidAll);
   rmSetObjectDefMinDistance(nugget2, 75.0);
   rmSetObjectDefMaxDistance(nugget2, 125.0);
   rmPlaceObjectDefPerPlayer(nugget2, false, 4);

   // Hard nuggets (3 per player, central part of the map)
   int nugget3= rmCreateObjectDef("nugget hard"); 
   rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(3, 3);
   rmAddObjectDefToClass(nugget3, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(nugget3, 0.0);
   rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.30));
   rmAddObjectDefConstraint(nugget3, shortPlayerConstraint);
   rmAddObjectDefConstraint(nugget3, avoidImpassableLand);
   rmAddObjectDefConstraint(nugget3, avoidNuggets);
   rmAddObjectDefConstraint(nugget3, circleConstraint);
   rmAddObjectDefConstraint(nugget3, avoidAll);
   rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);

   // Very hard nuggets (3 per player, anywhere on the map)
   int nugget4= rmCreateObjectDef("nugget nuts"); 
   rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(4, 4);
   rmAddObjectDefToClass(nugget4, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(nugget4, 0.0);
   rmSetObjectDefMaxDistance(nugget4, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(nugget4, longPlayerConstraint);
   rmAddObjectDefConstraint(nugget4, avoidImpassableLand);
   rmAddObjectDefConstraint(nugget4, avoidNuggets);
   rmAddObjectDefConstraint(nugget4, circleConstraint);
   rmAddObjectDefConstraint(nugget4, avoidAll);
   rmPlaceObjectDefAtLoc(nugget4, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);

   // Hard nuggets (3 per player, central part of the map)
   int nugget5= rmCreateObjectDef("nugget hard"); 
   rmAddObjectDefItem(nugget5, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 3);
   rmAddObjectDefToClass(nugget5, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(nugget5, 0.0);
   rmSetObjectDefMaxDistance(nugget5, rmXFractionToMeters(0.30));
   rmAddObjectDefConstraint(nugget5, shortPlayerConstraint);
   rmAddObjectDefConstraint(nugget5, avoidImpassableLand);
   rmAddObjectDefConstraint(nugget5, avoidNuggets);
   rmAddObjectDefConstraint(nugget5, circleConstraint);
   rmAddObjectDefConstraint(nugget5, avoidAll);
   rmPlaceObjectDefAtLoc(nugget5, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
   
   // Map generation status bar
   rmSetStatusText("",0.90);

   // Place Huari strongholds
   int huariCount = rmRandInt(cNumberNonGaiaPlayers-1,cNumberNonGaiaPlayers);
   int huariNorthID = rmCreateObjectDef("huari stronghold north");
   rmAddObjectDefItem(huariNorthID, "huaristrongholdandes", 1, 0.0);
   rmAddObjectDefToClass(huariNorthID, rmClassID("huari"));
   rmSetObjectDefMinDistance(huariNorthID, 0.0);
   rmSetObjectDefMaxDistance(huariNorthID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(huariNorthID, avoidImpassableLand);
   rmAddObjectDefConstraint(huariNorthID, avoidCoin);
   rmAddObjectDefConstraint(huariNorthID, longPlayerConstraint);
   rmAddObjectDefConstraint(huariNorthID, avoidCliffsShort);
   rmAddObjectDefConstraint(huariNorthID, avoidLakesShort);
   rmAddObjectDefConstraint(huariNorthID, avoidNatives);
   rmAddObjectDefConstraint(huariNorthID, avoidHuariLong);
   rmAddObjectDefConstraint(huariNorthID, avoidNuggetsHuari);
   rmAddObjectDefConstraint(huariNorthID, Northward);
   for(i=0; <huariCount)
   { 
      rmPlaceObjectDefAtLoc(huariNorthID, 0, 0.5, 0.5); // northern half of the map
   }
   int huariSouthID = rmCreateObjectDef("huari stronghold south");
   rmAddObjectDefItem(huariSouthID, "huaristrongholdandes", 1, 0.0);
   rmAddObjectDefToClass(huariSouthID, rmClassID("huari"));
   rmSetObjectDefMinDistance(huariSouthID, 0.0);
   rmSetObjectDefMaxDistance(huariSouthID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(huariSouthID, avoidImpassableLand);
   rmAddObjectDefConstraint(huariSouthID, avoidCoin);
   rmAddObjectDefConstraint(huariSouthID, longPlayerConstraint);
   rmAddObjectDefConstraint(huariSouthID, avoidCliffsShort);
   rmAddObjectDefConstraint(huariSouthID, avoidLakesShort);
   rmAddObjectDefConstraint(huariSouthID, avoidNatives);
   rmAddObjectDefConstraint(huariSouthID, avoidHuariLong);
   rmAddObjectDefConstraint(huariSouthID, avoidNuggetsHuari);
   rmAddObjectDefConstraint(huariSouthID, Southward);
   for(i=0; <huariCount)
   { 
      rmPlaceObjectDefAtLoc(huariSouthID, 0, 0.5, 0.5); // southern half of the map
   }

   // Map generation status bar
   rmSetStatusText("",1.0);

}  
